# sm-antd

[![NPM](https://img.shields.io/badge/npm-v1.1.3-blue)](https://www.npmjs.com/package/sm-antd)

## 介绍

`sm-antd` 是以 `Ant Design` 为基础进行拓展的一款 `React` UI 组件库。

---

## 特性

-   🌈 antd 主题色跟着项目配置走，并不会覆盖安装项目的主题。
-   📦 开箱即用，在 antd 原有组件的基础上扩展，并且支持原本 antd 组件的属性。
-   ⚙️ 沉前端组件，帮助规范代码
-   🌍 提高开发效率，让前端业务的时候更专注业务

## 安装

在项目中安装 `sm-antd`

```bash
npm install --save sm-antd
```

## 示例

```jsx
import React, { Component } from 'react'
import { SMTextSection } from 'sm-antd'

class Example extends Component {
    render() {
        return (
            <SMTextSection
                caseId='caseId'
                labelList
                currentTag='例子'
                onTagChange={(e) => {
                    console.log(e)
                }}
                text='React 使创建交互式 UI 变得轻而易举。'
            />
        )
    }
}
```

引入样式：

```jsx
import 'sm-antd/dist/index.css'
```