/**
 * SMDatePicker 基于antd DatePicker封装的时间戳组件
 * @Author      zoujiazhi(zoujiazhi@ishumei.com)
 *
 * 必传：
 * @param {Array}     setValue                设置初始时间
 * @param {string}    formatStr               设置moment格式化格式
 * @param {string}    dateType                设置时间面板(日期,月份)
 * @param {function}  onChange                时间改变发生的回调
 *
 * 选传:
 * @param {Object}   componentProps           antd自带属性
 * @param {object}   customStyle              自定义组件外层div的属性
 * @param {string}   fontInner                当dateType==='day'时可传入自定义组件中间字的内容
 * @param {Array}     weekCount               dateType==='week'  参数[number,string,string] weekCount[0]为需要加/减的数量
 *                                            weekCount[1]为需要加/减的 年月日   weekCount[2] 为 加还是减
 *
 */
import React from 'react';
import type { DatePickerProps } from 'antd';
import { PickerMode } from 'rc-picker/lib/interface';
export interface SMDatePickerProps {
    setValue: string[];
    formatStr: string;
    dateType: PickerMode;
    onChange: (startTime: string, endTime: string) => void;
    weekCount?: any[];
    fontInner?: string;
    customStyle?: React.CSSProperties;
    componentProps?: DatePickerProps & {
        showTime: any;
    };
}
declare const SMDatePicker: React.FC<SMDatePickerProps>;
export default SMDatePicker;
