/**
 * @Description     SMImageTable 是一个封装的图片组件，内置批量多选，自定义表头DOM，通用数美loading框等功能
 * @Author          caimingyu(caimingyu@ishumei.com)、junjie (yangjunjie@ishumei.com)
 * @Date            2021-08-28
 * @Path            sm-antd/src/components/SMImageTable
 * @Log             ts+hooks 重构
 */
import React from 'react';
import type { SMImageTableProps } from './interface';
/**
 * @param {Boolean}  loading             加载状态
 * @param {Array}    dataSource          数据源
 * @param {Number}   totalCount          总数
 * @param {Number}   current             当前页码
 * @param {Number}   pageSize            每页条数
 * @param {Array}    pageSizeOptions     每页条数配置
 * @param {Boolean}  isHidePagination    是否隐藏底部Pagination
 * @param {String}   idName              唯一标识字段名
 * @param {Object}   rowSelection        多选属性
 * @param {Object}   selectionExtraDom   多选自定义DOM
 * @param {Object}   extraDom            自定义表头DOM
 * @param {Function} onSearch            页码每页条数变化时的回调
 * @param {Object}   wrapperStyle        容器样式
 * @param {Function} renderItem          图片底部dom
 * @param {Number} rowNum              每行显示的图片数量
 * @param {object} antdPaginationProps antd分页组件的属性
 * @param {Number | String} imgWidth     图片宽度
 * @param {Number | String} imgHeight    图片高度
 */
declare const SMImageTable: React.FC<SMImageTableProps>;
export default SMImageTable;
