/// <reference types="react" />
export declare type StringOrNumber = string | number;
export interface RowSelection {
    onChange: (checkedList: StringOrNumber[]) => void;
    selectedRowKeys: StringOrNumber[];
}
export interface Record {
    url: string;
    [key: string]: StringOrNumber;
}
export interface SMImageTableProps {
    loading: boolean;
    totalCount: number;
    rowSelection: RowSelection;
    dataSource: any[];
    current?: number;
    pageSize?: number;
    pageSizeOptions?: string[];
    isHidePagination?: boolean;
    idName?: string;
    wrapperStyle?: React.CSSProperties;
    imgWidth?: StringOrNumber;
    imgHeight?: StringOrNumber;
    rowNum?: number;
    antdPaginationProps?: any;
    renderItem?: (record: Record) => React.ReactNode;
    extraDom?: any;
    selectionExtraDom?: () => React.ReactNode;
    onSearch?: (current: number, pageSize: number) => void;
}
export interface TableCorePorps {
    allCheckList: StringOrNumber[];
    dataSource: any[];
    idName?: string;
    onSelectChange?: (newSelect: StringOrNumber[]) => void;
    width?: StringOrNumber;
    height?: StringOrNumber;
    renderItem?: (record: Record) => React.ReactNode;
    rowNum?: number;
}
