/**
 * @Description     基于antd中Select二次封装
 * @Author          chenhaojie(chenhaojie@ishumei.com)
 * @Date            2021-07-13
 * @Path            sm-antd/src/components/SMSelect
 * /
/**
 * 组件自定义参数
 * @param  data               数据源
 * @param  labelName          label
 * @param  valueName          value
 * @param  isAddAll           是否添加全部
 * @param  renderCustomLabel  自定义渲染的dom
 * antd 原生配置项 可直接通过props传递
 * <SMSlect
    mode='multiple'
    value='xxx'
    ...
   ></SMSlect>
 */
import React from 'react';
import type { SelectProps } from 'antd';
export interface SMSelectProps extends SelectProps<any> {
    data?: any[];
    labelName?: string;
    valueName?: string;
    isAddAll?: boolean;
    renderCustomLabel?: (item: any) => React.ReactNode;
}
declare const SMSelect: React.FC<SMSelectProps>;
export default SMSelect;
