import React from 'react';
/**
 * @Author          Dojee(yangjunjie@ishumei.com)
 * @Date            2021-08-26
 * @Path            sm-antd/src/components/SMText
 * /

/**
 * 文本组件 支持关键词标红，渲染html
 *
 *
 *  @param {string}   keywords              标红的关键词
 *  @param {String}   content               文本内容
 *  @param {String}   defaultContent        默认文本
 *  @param {Boolean}  ellipsis              是否换行
 *  @param {String}   color                 是否加载完直接播放
 *  @param {String}   delimiter             关键词分割字符
 *  @param {Boolean}  escapeHtmlFlag        是否对文本中的html转义
 *
 */
export interface SMTextProps {
    keywords: string;
    content: string;
    defaultContent: string;
    ellipsis: boolean;
    color: string;
    delimiter: string;
    escapeHtmlFlag: boolean;
}
declare const KeywordsHighLight: React.FC<SMTextProps>;
export default KeywordsHighLight;
