/**
 * @Description     ModalRoot 是一个弹窗注册器，内置三种弹窗
 * @Author          junjie (yangjunjie@ishumei.com)
 * @Date            2021-09-01
 * @Log             用ts+hooks 重构, 注册机制重构
 */
import React from 'react';
export declare const MAX_MODAL_NUMBER = 10;
export declare const MODAL_COMPONENTS: {
    MODAL_ALERT: React.FC<import("./AlertModal").AlertModalProps>;
    MODAL_HOC: React.FC<import("./HocModal").HocModalProps>;
    BASE_DRAWER: React.ForwardRefExoticComponent<import("./BaseDrawer").BaseDrawerProps & React.RefAttributes<import("./BaseDrawer").BaseDrawerRef>>;
};
export interface ModalRootProps {
    modalComponents?: any;
    maxNumber?: number;
}
export interface ModalRootRef {
    show: (modalType: string, modalProps: any) => void;
    pop: (deep?: number, modalType?: string) => void;
    clearModals: () => void;
}
declare const ModalRoot: React.ForwardRefExoticComponent<ModalRootProps & React.RefAttributes<ModalRootRef>>;
export default ModalRoot;
