import React, { useRef, useCallback, useEffect, useState, useMemo, useLayoutEffect, Component, Fragment, forwardRef, useImperativeHandle } from 'react';
import { Popover, Checkbox, Tooltip, Tree, ConfigProvider, Table, Pagination, Select, Button, Upload, Modal, Row, Col, Radio, Cascader, DatePicker, InputNumber, Input, Form, Slider, Drawer } from 'antd';
export { ConfigProvider } from 'antd';
import _ from 'lodash-es';
import { useTranslation, withTranslation } from 'react-i18next';
import { Resizable } from 'react-resizable';
import { useIntl } from '@ant-design/pro-provider';
import { SettingOutlined, VerticalAlignTopOutlined, VerticalAlignMiddleOutlined, VerticalAlignBottomOutlined, ExclamationCircleFilled, QuestionCircleOutlined, CloseOutlined, PauseCircleFilled, PlayCircleFilled, SoundOutlined, DownloadOutlined, RedoOutlined } from '@ant-design/icons';
import { createContainer } from 'unstated-next';
import locale from 'antd/es/locale/zh_CN';
import LazyLoad from 'react-lazy-load';
import Zmage from 'react-zmage';
import moment from 'moment';
import { withRouter } from 'react-router-dom';

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

var genColumnKey = function genColumnKey(key, index) {
  if (key) {
    return Array.isArray(key) ? key.join('-') : key.toString();
  }
  return "" + index;
};

/* loaded by smart-asset */
var loadingUrl = require("./loading~blJHhrKH.gif");

var styles = {"icon-loading-wrapper":"_28Oxv"};

var IconLoading = function IconLoading(props) {
  var customLoadingUrl = props.customLoadingUrl;
  return React.createElement("div", {
    className: styles['icon-loading-wrapper']
  }, React.createElement("img", {
    src: customLoadingUrl || loadingUrl,
    width: '32',
    height: '32'
  }));
};

var noData = require("./noData~wIYZCJPs.png");

var styles$1 = {"render-empty-container":"_2-1R-","render-empty-img":"_3C45R","render-empty-title":"_2KVcJ"};

var CustomizeRenderEmpty = function CustomizeRenderEmpty(props) {
  var _props$nodeData = props.nodeData,
    nodeData = _props$nodeData === void 0 ? '暂无数据' : _props$nodeData;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  return React.createElement("div", {
    className: styles$1['render-empty-container']
  }, React.createElement("img", {
    src: noData,
    alt: "",
    className: styles$1['render-empty-img']
  }), React.createElement("p", {
    className: styles$1['render-empty-title']
  }, t(nodeData)));
};

var formatTime = function formatTime(time) {
  var hRemainder = time % 3600;
  var h = parseInt(time / 3600, 10);
  var m = parseInt(hRemainder / 60, 10);
  var s = parseInt(hRemainder % 60, 10);
  if (time >= 3600) {
    return youngerTime(h) + ":" + youngerTime(m) + ":" + youngerTime(s);
  }
  return youngerTime(m) + ":" + youngerTime(s);
};
var youngerTime = function youngerTime(val) {
  return val < 10 ? '0' + val : val;
};
var guid = function guid() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0;
    var v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
};
var storage = {
  set: function set(key, value, expires) {
    var params = {
      key: key,
      value: value,
      expires: expires
    };
    if (expires) {
      var data = Object.assign(params, {
        startTime: new Date().getTime()
      });
      window.localStorage.setItem(key, JSON.stringify(data));
    } else {
      if (Object.prototype.toString.call(value) === '[object Object]') {
        value = JSON.stringify(value);
      }
      if (Object.prototype.toString.call(value) === '[object Array]') {
        value = JSON.stringify(value);
      }
      window.localStorage.setItem(key, value);
    }
  },
  get: function get(key) {
    var item = window.localStorage.getItem(key);
    try {
      item = JSON.parse(item);
    } catch (error) {
      item = item;
    }
    if (item && item.startTime) {
      var date = new Date().getTime();
      if (date - item.startTime > item.expires) {
        localStorage.removeItem(key);
        return false;
      }
      return item.value;
    }
    return item;
  },
  remove: function remove(key) {
    window.localStorage.removeItem(key);
  },
  clear: function clear() {
    window.localStorage.clear();
  }
};
var getBase64 = function getBase64(file) {
  return new Promise(function (resolve, reject) {
    var reader = new window.FileReader();
    reader.readAsDataURL(file);
    reader.onload = function () {
      return resolve(reader.result);
    };
    reader.onerror = function (error) {
      return reject(error);
    };
  });
};

var downloadFile = function downloadFile(url, fileName) {
  var XMLHttpRequest = window.XMLHttpRequest;
  var request = new XMLHttpRequest();
  request.open('GET', url, true);
  request.responseType = 'blob';
  request.onload = function () {
    var url = window.URL.createObjectURL(request.response);
    var a = document.createElement('a');
    a.href = url;
    a.download = fileName;
    a.click();
  };
  request.onerror = function () {
    window.open(url);
  };
  request.send();
};

var columnSort = function columnSort(columnsMap) {
  return function (a, b) {
    var _columnsMap$aKey, _columnsMap$bKey;
    var aFixed = a.fixed,
      aIndex = a.index;
    var bFixed = b.fixed,
      bIndex = b.index;
    if (aFixed === 'left' && bFixed !== 'left' || bFixed === 'right' && aFixed !== 'right') {
      return -2;
    }
    if (bFixed === 'left' && aFixed !== 'left' || aFixed === 'right' && bFixed !== 'right') {
      return 2;
    }
    var aKey = a.key || "" + aIndex;
    var bKey = b.key || "" + bIndex;
    if ((_columnsMap$aKey = columnsMap[aKey]) !== null && _columnsMap$aKey !== void 0 && _columnsMap$aKey.order || (_columnsMap$bKey = columnsMap[bKey]) !== null && _columnsMap$bKey !== void 0 && _columnsMap$bKey.order) {
      var _columnsMap$aKey2, _columnsMap$bKey2;
      return (((_columnsMap$aKey2 = columnsMap[aKey]) === null || _columnsMap$aKey2 === void 0 ? void 0 : _columnsMap$aKey2.order) || 0) - (((_columnsMap$bKey2 = columnsMap[bKey]) === null || _columnsMap$bKey2 === void 0 ? void 0 : _columnsMap$bKey2.order) || 0);
    }
    return (a.index || 0) - (b.index || 0);
  };
};

function useContainer() {
  var sortKeyColumns = useRef([]);
  return {
    sortKeyColumns: sortKeyColumns,
    setSortKeyColumns: function setSortKeyColumns(keys) {
      sortKeyColumns.current = keys;
    }
  };
}
var Container = createContainer(useContainer);

var _excluded = ["key"];
var ToolTipIcon = function ToolTipIcon(_ref) {
  var title = _ref.title,
    show = _ref.show,
    children = _ref.children,
    columnKey = _ref.columnKey,
    fixed = _ref.fixed,
    props = _ref.props;
  var setChangeColumnsMap = props.setChangeColumnsMap,
    columnsMap = props.columnsMap;
  if (!show) {
    return null;
  }
  return React.createElement(Tooltip, {
    title: title
  }, React.createElement("span", {
    onClick: function onClick(e) {
      var _extends2;
      e.stopPropagation();
      e.preventDefault();
      var config = columnsMap[columnKey] || {};
      var columnKeyMap = _extends({}, columnsMap, (_extends2 = {}, _extends2[columnKey] = _extends({}, config, {
        fixed: fixed
      }), _extends2));
      setChangeColumnsMap(columnKeyMap);
    }
  }, children));
};
var CheckboxListItem = function CheckboxListItem(_ref2) {
  var columnKey = _ref2.columnKey,
    title = _ref2.title,
    fixed = _ref2.fixed,
    props = _ref2.props;
  var intl = useIntl();
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var _props$i18nText = props.i18nText,
    _props$i18nText$unfix = _props$i18nText.unfixed,
    unfixed = _props$i18nText$unfix === void 0 ? '不固定' : _props$i18nText$unfix,
    _props$i18nText$fixed = _props$i18nText.fixedFirst,
    fixedFirst = _props$i18nText$fixed === void 0 ? '固定在列首' : _props$i18nText$fixed,
    _props$i18nText$fixed2 = _props$i18nText.fixedLast,
    fixedLast = _props$i18nText$fixed2 === void 0 ? '固定在列尾' : _props$i18nText$fixed2;
  return React.createElement("span", {
    key: columnKey,
    style: {
      display: 'flex',
      justifyContent: 'space-between'
    }
  }, React.createElement("span", null, title), React.createElement("span", null, React.createElement(ToolTipIcon, {
    columnKey: columnKey,
    fixed: "left",
    title: t(fixedFirst),
    show: fixed !== 'left',
    props: props
  }, React.createElement(VerticalAlignTopOutlined, null)), React.createElement(ToolTipIcon, {
    columnKey: columnKey,
    fixed: undefined,
    title: t(unfixed),
    show: !!fixed,
    props: props
  }, React.createElement(VerticalAlignMiddleOutlined, null)), React.createElement(ToolTipIcon, {
    columnKey: columnKey,
    fixed: "right",
    title: t(fixedLast),
    show: fixed !== 'right',
    props: props
  }, React.createElement(VerticalAlignBottomOutlined, null))));
};
var CheckboxList = function CheckboxList(_ref3) {
  var list = _ref3.list,
    draggable = _ref3.draggable,
    checkable = _ref3.checkable,
    className = _ref3.className,
    _ref3$showTitle = _ref3.showTitle,
    showTitle = _ref3$showTitle === void 0 ? true : _ref3$showTitle,
    listTitle = _ref3.title,
    props = _ref3.props;
  var _Container$useContain = Container.useContainer(),
    sortKeyColumns = _Container$useContain.sortKeyColumns,
    setSortKeyColumns = _Container$useContain.setSortKeyColumns;
  var setChangeColumnsMap = props.setChangeColumnsMap,
    columnsMap = props.columnsMap;
  var show = list.length > 0;
  var move = useCallback(function (id, targetId, dropPosition) {
    var newMap = _extends({}, columnsMap);
    var newColumns = [].concat(sortKeyColumns.current);
    var findIndex = newColumns.findIndex(function (columnKey) {
      return columnKey === id;
    });
    var targetIndex = newColumns.findIndex(function (columnKey) {
      return columnKey === targetId;
    });
    var isDownWord = dropPosition > findIndex;
    if (findIndex < 0) {
      return;
    }
    var targetItem = newColumns[findIndex];
    newColumns.splice(findIndex, 1);
    if (dropPosition === 0) {
      newColumns.unshift(targetItem);
    } else {
      newColumns.splice(isDownWord ? targetIndex : targetIndex + 1, 0, targetItem);
    }
    newColumns.forEach(function (key, order) {
      newMap[key] = _extends({}, newMap[key] || {}, {
        order: order
      });
    });
    setChangeColumnsMap(newMap);
    setSortKeyColumns(newColumns);
  }, [columnsMap, setChangeColumnsMap, setSortKeyColumns, sortKeyColumns]);
  if (!show) {
    return null;
  }
  var checkedKeys = [];
  var treeData = list.map(function (_ref4) {
    var key = _ref4.key,
      rest = _objectWithoutPropertiesLoose(_ref4, _excluded);
    var columnKey = genColumnKey(key, rest.index);
    var config = columnsMap[columnKey || 'null'] || {
      show: true
    };
    if (config.show !== false) {
      checkedKeys.push(columnKey);
    }
    return _extends({
      key: columnKey,
      selectable: false,
      switcherIcon: function switcherIcon() {
        return false;
      }
    }, _.omit(rest, ['className']));
  });
  var listDom = React.createElement(Tree, {
    itemHeight: 24,
    draggable: draggable,
    checkable: checkable,
    onDrop: function onDrop(info) {
      var dropKey = info.node.key;
      var dragKey = info.dragNode.key;
      var dropPosition = info.dropPosition,
        dropToGap = info.dropToGap;
      var position = dropPosition === -1 || !dropToGap ? dropPosition + 1 : dropPosition;
      move(dragKey, dropKey, position);
    },
    blockNode: true,
    onCheck: function onCheck(_, e) {
      var _extends3;
      var columnKey = e.node.key;
      var tempConfig = columnsMap[columnKey] || {};
      var newSetting = _extends({}, tempConfig);
      if (e.checked) {
        delete newSetting.show;
      } else {
        newSetting.show = false;
      }
      var columnKeyMap = _extends({}, columnsMap, (_extends3 = {}, _extends3[columnKey] = newSetting, _extends3));
      if (Object.keys(newSetting).length === 0) {
        delete columnKeyMap[columnKey];
      }
      setChangeColumnsMap(columnKeyMap);
    },
    checkedKeys: checkedKeys,
    showLine: false,
    titleRender: function titleRender(node) {
      return React.createElement(CheckboxListItem, Object.assign({
        props: props,
        className: className
      }, node, {
        columnKey: node.key
      }));
    },
    treeData: treeData
  });
  return React.createElement("span", null, showTitle && React.createElement("span", {
    className: className + "-list-title"
  }, listTitle), listDom);
};
var GroupCheckboxList = function GroupCheckboxList(_ref5) {
  var localColumns = _ref5.localColumns,
    draggable = _ref5.draggable,
    checkable = _ref5.checkable,
    props = _ref5.props;
  var rightList = [];
  var leftList = [];
  var list = [];
  var intl = useIntl();
  var _useTranslation2 = useTranslation(),
    t = _useTranslation2.t;
  var _ref6 = props.i18nText || {},
    _ref6$unfixed = _ref6.unfixed,
    unfixed = _ref6$unfixed === void 0 ? '不固定' : _ref6$unfixed,
    _ref6$fixedFirst = _ref6.fixedFirst,
    fixedFirst = _ref6$fixedFirst === void 0 ? '固定在列首' : _ref6$fixedFirst,
    _ref6$fixedLeft = _ref6.fixedLeft,
    fixedLeft = _ref6$fixedLeft === void 0 ? '固定在左侧' : _ref6$fixedLeft;
  localColumns.forEach(function (item) {
    var fixed = item.fixed;
    if (fixed === 'left') {
      leftList.push(item);
      return;
    }
    if (fixed === 'right') {
      rightList.push(item);
      return;
    }
    if (item.hideInSetting) {
      return;
    }
    list.push(item);
  });
  var showRight = rightList && rightList.length > 0;
  var showLeft = leftList && leftList.length > 0;
  return React.createElement("div", null, React.createElement(CheckboxList, {
    title: t(fixedLeft),
    list: leftList,
    draggable: draggable,
    checkable: checkable,
    props: props
  }), React.createElement(CheckboxList, {
    list: list,
    draggable: draggable,
    checkable: checkable,
    title: t(unfixed),
    showTitle: showLeft || showRight,
    props: props
  }), React.createElement(CheckboxList, {
    title: t(fixedFirst),
    list: rightList,
    draggable: draggable,
    checkable: checkable,
    props: props
  }));
};
function ColumnSetting(props) {
  var _props$checkable, _props$draggable;
  var columnRef = useRef({});
  var localColumns = props.localColumns;
  var _Container$useContain2 = Container.useContainer(),
    setSortKeyColumns = _Container$useContain2.setSortKeyColumns;
  var columnKeys = props.localColumns.map(function (item) {
    return genColumnKey(item.key);
  });
  setSortKeyColumns(columnKeys);
  var setChangeColumnsMap = props.setChangeColumnsMap,
    columnsMap = props.columnsMap,
    popoverStyle = props.popoverStyle,
    i18nText = props.i18nText;
  var _i18nText$columnDispl = i18nText.columnDisplay,
    columnDisplay = _i18nText$columnDispl === void 0 ? '列展示' : _i18nText$columnDispl,
    _i18nText$columnSetti = i18nText.columnSetting,
    columnSetting = _i18nText$columnSetti === void 0 ? '列设置' : _i18nText$columnSetti,
    _i18nText$reset = i18nText.reset,
    reset = _i18nText$reset === void 0 ? '重置' : _i18nText$reset;
  var setAllSelectAction = useCallback(function (show) {
    if (show === void 0) {
      show = true;
    }
    var columnKeyMap = {};
    localColumns.forEach(function (_ref7) {
      var key = _ref7.key,
        fixed = _ref7.fixed,
        index = _ref7.index;
      var columnKey = genColumnKey(key, index);
      if (columnKey) {
        columnKeyMap[columnKey] = {
          show: show,
          fixed: fixed
        };
      }
    });
    setChangeColumnsMap(columnKeyMap);
  }, [localColumns, setChangeColumnsMap]);
  useEffect(function () {
    columnRef.current = localColumns;
  }, [localColumns]);
  var selectedKeys = Object.values(columnsMap).filter(function (value) {
    return !value || value.show === false;
  });
  var indeterminate = selectedKeys.length > 0 && selectedKeys.length !== localColumns.length;
  var intl = useIntl();
  var _useTranslation3 = useTranslation(),
    t = _useTranslation3.t;
  return React.createElement(Popover, {
    arrowPointAtCenter: true,
    title: React.createElement("div", null, React.createElement(Checkbox, {
      indeterminate: indeterminate,
      checked: selectedKeys.length === 0 && selectedKeys.length !== localColumns.length,
      onChange: function onChange(e) {
        if (e.target.checked) {
          setAllSelectAction();
        } else {
          setAllSelectAction(false);
        }
      }
    }, t(columnDisplay)), React.createElement("a", {
      onClick: function onClick() {
        setChangeColumnsMap(columnRef.current, true);
      }
    }, t(reset))),
    overlayStyle: popoverStyle,
    placement: "bottomRight",
    content: React.createElement(GroupCheckboxList, {
      checkable: (_props$checkable = props.checkable) != null ? _props$checkable : true,
      draggable: (_props$draggable = props.draggable) != null ? _props$draggable : true,
      localColumns: localColumns,
      props: props
    })
  }, React.createElement(Tooltip, {
    title: t(columnSetting)
  }, React.createElement(SettingOutlined, {
    style: {
      marginLeft: '10px'
    }
  })));
}

var styles$2 = {"sm-table-wrapper":"_2t343","operator-wrapper":"_1LygG","operator":"_lptD-","operator-wrapper-select":"_T2K1C","operator-wrapper-select-show":"_2n8SE","operator-create":"_2Bwvl"};

var _excluded$1 = ["onResize", "width"];
var ResizableTitle = function ResizableTitle(props) {
  var onResize = props.onResize,
    width = props.width,
    restProps = _objectWithoutPropertiesLoose(props, _excluded$1);
  if (!width) {
    return React.createElement("th", Object.assign({}, restProps));
  }
  return React.createElement(Resizable, {
    width: width,
    height: 0,
    handle: React.createElement("span", {
      className: "react-resizable-handle",
      onClick: function onClick(e) {
        e.stopPropagation();
      }
    }),
    onResize: onResize,
    draggableOpts: {
      enableUserSelectHack: false
    }
  }, React.createElement("th", Object.assign({}, restProps)));
};
var SMTable = function SMTable(props) {
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var dataSource = props.dataSource,
    columns = props.columns,
    selectionExtraDom = props.selectionExtraDom,
    selectShowDom = props.selectShowDom,
    onSearch = props.onSearch,
    _props$totalCount = props.totalCount,
    total = _props$totalCount === void 0 ? 0 : _props$totalCount,
    propsRowSelection = props.rowSelection,
    _props$loading = props.loading,
    loading = _props$loading === void 0 ? false : _props$loading,
    isHidePagination = props.isHidePagination,
    idName = props.idName,
    antdProps = props.antdProps,
    extraDom = props.extraDom,
    scroll = props.scroll,
    showTotal = props.showTotal,
    _props$current = props.current,
    current = _props$current === void 0 ? 1 : _props$current,
    _props$pageSize = props.pageSize,
    pageSize = _props$pageSize === void 0 ? 20 : _props$pageSize,
    _props$pageSizeOption = props.pageSizeOptions,
    pageSizeOptions = _props$pageSizeOption === void 0 ? ['20', '30', '50', '100'] : _props$pageSizeOption,
    propsPagination = props.pagination,
    setTableKey = props.setTableKey,
    setLocalTable = props.setLocalTable,
    popoverStyle = props.popoverStyle,
    _props$i18nText = props.i18nText,
    i18nText = _props$i18nText === void 0 ? {} : _props$i18nText,
    _props$isDrag = props.isDrag,
    isDrag = _props$isDrag === void 0 ? false : _props$isDrag,
    getNewTableColumn = props.getNewTableColumn,
    customLoadingUrl = props.customLoadingUrl;
  var _useState = useState({}),
    rowSelection = _useState[0],
    setRowSelection = _useState[1];
  var _useState2 = useState({
      showSizeChanger: true,
      defaultPageSize: 20,
      showQuickJumper: true
    }),
    pagination = _useState2[0],
    setPagination = _useState2[1];
  var _useState3 = useState({}),
    columnsMap = _useState3[0],
    setColumnsMap = _useState3[1];
  var _useState4 = useState([]),
    newTableColumn = _useState4[0],
    setNewTableColumn = _useState4[1];
  var handleColumns = useCallback(function (columns, columnsKeyMap, needFilter) {
    var localColumns = storage.get(setTableKey) || columnsKeyMap;
    var filterColumns = columns.map(function (col) {
      var columnKey = genColumnKey(col.key);
      var config = localColumns[columnKey] || {
        fixed: localColumns.fixed
      };
      return _extends({}, col, {
        fixed: config.fixed
      });
    }).filter(function (item, index) {
      var columnKey = genColumnKey(item.key, index);
      var config = localColumns ? localColumns[columnKey] : '';
      if (config && config.show === false && !needFilter) {
        return false;
      }
      return true;
    }).sort(columnSort(localColumns));
    return filterColumns;
  }, [setTableKey]);
  var handleInitTable = useCallback(function (columns, reset) {
    var newDefaultColumn = columns.filter(function (item) {
      return !item.defaultHide;
    });
    var newTableColumn = setTableKey && storage.get(setTableKey) ? handleColumns(columns) : newDefaultColumn;
    if (reset) {
      storage.remove(setTableKey);
    }
    var columnsMap = {};
    _.forEach(columns, function (_ref, index) {
      var key = _ref.key,
        fixed = _ref.fixed,
        defaultHide = _ref.defaultHide;
      var columnKey = genColumnKey(key, index);
      if (columnKey) {
        columnsMap[columnKey] = {
          show: !defaultHide,
          fixed: fixed
        };
      }
    });
    setColumnsMap(columnsMap);
    setNewTableColumn(reset ? newDefaultColumn : newTableColumn);
  }, [handleColumns, setTableKey]);
  var assignmentPagination = useCallback(function () {
    var currentPagination = _extends({
      current: current,
      pageSize: pageSize
    }, pagination);
    setPagination(currentPagination);
  }, [current, pageSize, pagination]);
  var mergePagonation = useMemo(function () {
    return _extends({
      total: total,
      showTotal: showTotal ? showTotal : function (total) {
        return t('共') + " " + total + " " + t('条');
      },
      pageSizeOptions: pageSizeOptions
    }, pagination, propsPagination);
  }, [total, showTotal, pageSizeOptions, pagination, propsPagination, t]);
  var getOperatorTpl = useCallback(function () {
    var _i18nText$selectText = i18nText.selectText,
      selectText = _i18nText$selectText === void 0 ? '已选择' : _i18nText$selectText,
      _i18nText$totalText = i18nText.totalText,
      totalText = _i18nText$totalText === void 0 ? '总计' : _i18nText$totalText,
      _i18nText$itemText = i18nText.itemText,
      itemText = _i18nText$itemText === void 0 ? '项' : _i18nText$itemText;
    return React.createElement("div", {
      className: styles$2.operator
    }, selectionExtraDom && rowSelection && React.createElement("div", {
      className: styles$2['operator-wrapper-select']
    }, React.createElement("div", {
      className: styles$2['operator-wrapper-select-show']
    }, selectText, React.createElement("span", null, _.size(rowSelection.selectedRowKeys)), itemText, " ", totalText, " ", total, " ", itemText, selectShowDom && selectShowDom()), selectionExtraDom()), extraDom && React.createElement("div", {
      style: {
        flex: selectionExtraDom ? 'none' : 'auto'
      },
      className: styles$2['operator-wrapper']
    }, extraDom), setTableKey && React.createElement(ColumnSetting, {
      localColumns: handleColumns(columns, columnsMap, true),
      columnsMap: storage.get(setTableKey) || columnsMap,
      popoverStyle: popoverStyle,
      i18nText: i18nText,
      setChangeColumnsMap: function setChangeColumnsMap(columnsKeyMap, reset) {
        if (reset) {
          handleInitTable(columns, true);
        } else {
          setLocalTable && setTableKey && storage.set(setTableKey, columnsKeyMap);
          setColumnsMap(columnsKeyMap);
          setNewTableColumn(handleColumns(columns, columnsKeyMap));
        }
      }
    }));
  }, [selectionExtraDom, rowSelection, total, selectShowDom, extraDom, setTableKey, handleColumns, columns, columnsMap, handleInitTable, setLocalTable, popoverStyle, i18nText]);
  var handleTableChange = useCallback(function (pagination) {
    var current = pagination.current,
      pageSize = pagination.pageSize;
    setPagination(_extends({}, pagination));
    onSearch && onSearch(current, pageSize);
  }, [onSearch]);
  var handleResize = function handleResize(index) {
    return function (_, _ref2) {
      var size = _ref2.size;
      var newColumns = [].concat(newTableColumn);
      newColumns[index] = _extends({}, newColumns[index], {
        width: size.width
      });
      setNewTableColumn(newColumns);
      getNewTableColumn === null || getNewTableColumn === void 0 ? void 0 : getNewTableColumn(newColumns);
    };
  };
  var tableProps = useMemo(function () {
    var propsObject = _extends({
      rowSelection: rowSelection,
      dataSource: dataSource,
      loading: {
        spinning: loading,
        indicator: React.createElement(IconLoading, {
          customLoadingUrl: customLoadingUrl
        })
      },
      pagination: isHidePagination ? false : mergePagonation,
      rowKey: function rowKey(item) {
        return item[idName || 'id'];
      },
      scroll: scroll,
      onChange: handleTableChange,
      columns: newTableColumn
    }, antdProps);
    if (isDrag) {
      propsObject.columns = newTableColumn.map(function (col, index) {
        return _extends({}, col, {
          onHeaderCell: function onHeaderCell(column) {
            return {
              width: column.width,
              onResize: handleResize(index)
            };
          }
        });
      });
      propsObject.components = {
        header: {
          cell: ResizableTitle
        }
      };
    }
    return propsObject;
  }, [newTableColumn, dataSource, loading]);
  useEffect(function () {
    setRowSelection(propsRowSelection);
    assignmentPagination();
    handleInitTable(columns, false);
  }, [columns, handleInitTable, propsRowSelection]);
  return React.createElement(Container.Provider, null, React.createElement("div", {
    className: "" + styles$2['sm-table-wrapper']
  }, getOperatorTpl(), React.createElement("div", {
    className: styles$2['table-wrapper']
  }, React.createElement(ConfigProvider, {
    renderEmpty: function renderEmpty() {
      return React.createElement(CustomizeRenderEmpty, Object.assign({}, i18nText));
    }
  }, React.createElement(Table, Object.assign({}, tableProps))))));
};

var styles$3 = {"image-detail-wrapper":"_3R-eh","img-wrap":"_2RUlB","image-detail-img":"_1-fkg","image-hidden":"_21pAp","image-pop":"_XIYPS"};

var SMImage = (function (props) {
  var _props$width = props.width,
    width = _props$width === void 0 ? 300 : _props$width,
    _props$height = props.height,
    height = _props$height === void 0 ? 300 : _props$height,
    _props$url = props.url,
    url = _props$url === void 0 ? '' : _props$url,
    onImageLoaded = props.onImageLoaded,
    _props$thumbUrl = props.thumbUrl,
    thumbUrl = _props$thumbUrl === void 0 ? '' : _props$thumbUrl;
  var _useState = useState(false),
    thumbImgLoad = _useState[0],
    setThumbImgLoad = _useState[1];
  var popHtml = useMemo(function () {
    return React.createElement("div", {
      style: {
        textAlign: 'center'
      }
    }, React.createElement("img", {
      src: thumbUrl ? thumbUrl : url,
      alt: "\u56FE\u7247\u52A0\u8F7D\u5931\u8D25",
      className: styles$3['image-pop']
    }));
  }, [thumbUrl, url]);
  var handleClick = useCallback(function () {
    return Zmage.browsing({
      src: url,
      edge: 20,
      backdrop: 'rgba(255,255,255, 0.8)',
      animate: {
        flip: 'zoom'
      },
      controller: {
        close: true,
        zoom: true,
        download: false,
        rotate: false,
        flip: false,
        pagination: false
      }
    });
  }, [url]);
  return React.createElement("div", {
    className: styles$3['image-detail-wrapper'],
    style: {
      width: width,
      height: height
    }
  }, React.createElement("div", {
    className: styles$3['image-hidden']
  }, thumbImgLoad && React.createElement("img", {
    src: url,
    alt: "\u56FE\u7247\u52A0\u8F7D\u5931\u8D25",
    onLoad: function onLoad() {
      return onImageLoaded && onImageLoaded(true);
    },
    onError: function onError() {
      return onImageLoaded && onImageLoaded(false);
    }
  })), React.createElement(LazyLoad, null, React.createElement(Popover, {
    content: popHtml,
    trigger: "hover",
    placement: "right"
  }, React.createElement("div", {
    className: styles$3['img-wrap'],
    style: {
      width: width,
      height: height
    }
  }, React.createElement("img", {
    className: styles$3['image-detail-img'],
    src: thumbUrl ? thumbUrl : url,
    loading: "lazy",
    alt: "\u56FE\u7247\u52A0\u8F7D\u5931\u8D25",
    onClick: handleClick,
    onLoad: function onLoad() {
      return setThumbImgLoad(true);
    },
    onError: function onError() {
      return setThumbImgLoad(true);
    }
  })))));
});

var styles$4 = {"sm-imgtable-wrapper":"_1z7AK","imgtable-wrapper-loading":"_OAgF8","operator-wrapper":"_2JvBc","operator":"_1_oRl","sm-imgtable-pagination":"_3OEb4","image-table":"_3PQB0","image-table-item":"_2htfW","image-table-item-checkbox-wapper":"_-fR5m","image-table-item-render":"_24vbr","image-table-item-checkbox":"_3s8RH"};

var TableCore = function TableCore(props) {
  var _props$allCheckList = props.allCheckList,
    allCheckList = _props$allCheckList === void 0 ? [] : _props$allCheckList,
    idName = props.idName,
    dataSource = props.dataSource,
    onSelectChange = props.onSelectChange,
    _props$width = props.width,
    width = _props$width === void 0 ? 150 : _props$width,
    _props$height = props.height,
    height = _props$height === void 0 ? 150 : _props$height,
    renderItem = props.renderItem,
    rowNum = props.rowNum;
  var _useState = useState([]),
    selectedRowKeys = _useState[0],
    setSelectedRowKeys = _useState[1];
  var checkHandle = useCallback(function (e, checked) {
    var newSelect = [].concat(selectedRowKeys);
    if (checked) {
      newSelect.push(e);
    } else {
      var index = newSelect.findIndex(function (val) {
        return val === e;
      });
      if (index !== -1) {
        newSelect.splice(index, 1);
      }
    }
    onSelectChange && onSelectChange(newSelect);
  }, [onSelectChange, selectedRowKeys]);
  useEffect(function () {
    var newCheckList = [];
    dataSource.map(function (val) {
      if (allCheckList.findIndex(function (e) {
        return e === val[idName];
      }) !== -1) {
        newCheckList.push(val[idName]);
      }
    });
    setSelectedRowKeys(newCheckList);
  }, [allCheckList, dataSource, idName]);
  return React.createElement("div", {
    className: styles$4['image-table'],
    style: {
      gridTemplateColumns: "repeat(auto-fill, " + 100 / rowNum + "%)"
    }
  }, dataSource.map(function (record) {
    var url = record.url;
    var checked = selectedRowKeys.findIndex(function (val) {
      return val === record[idName];
    }) !== -1;
    return React.createElement("div", {
      key: record[idName],
      className: styles$4['image-table-item']
    }, React.createElement("div", {
      style: {
        width: width
      },
      className: styles$4['image-table-item-checkbox-wapper']
    }, onSelectChange && React.createElement(Checkbox, {
      className: styles$4['image-table-item-checkbox'],
      checked: checked,
      onChange: function onChange(e) {
        return checkHandle(record[idName], e.target.checked);
      }
    }), React.createElement(SMImage, {
      width: width,
      height: height,
      url: url
    })), React.createElement("div", {
      className: styles$4['image-table-item-render']
    }, renderItem && renderItem(record)));
  }));
};

var styles$5 = {"operator-wrapper":"_2CFiK","operator-wrapper-left":"_3XzR-","operator-wrapper-left-icon":"_1Lv24","operator-wrapper-show":"_16a-M"};

var BatchOperationBar = function BatchOperationBar(props) {
  var selectionExtraDom = props.selectionExtraDom,
    selectLength = props.selectLength,
    totalCount = props.totalCount,
    currentTotalCount = props.currentTotalCount,
    onCheckAllChange = props.onCheckAllChange;
  var isIndeterminate = selectLength < currentTotalCount && selectLength > 0;
  var isCheckout = selectLength >= currentTotalCount && selectLength !== 0;
  return React.createElement("div", {
    className: styles$5['operator-wrapper']
  }, React.createElement("div", {
    className: styles$5['operator-wrapper-left']
  }, onCheckAllChange && React.createElement(Checkbox, {
    style: {
      marginRight: 10
    },
    indeterminate: isIndeterminate,
    checked: isCheckout,
    onChange: onCheckAllChange
  }), React.createElement(ExclamationCircleFilled, {
    className: styles$5['operator-wrapper-left-icon'],
    style: {
      color: '#36c6d3'
    }
  }), React.createElement("div", {
    className: styles$5['operator-wrapper-show']
  }, "\u5DF2\u9009\u62E9 ", React.createElement("span", null, selectLength), " \u9879 \u603B\u8BA1 ", totalCount, " \u9879")), selectionExtraDom && selectionExtraDom());
};

var SMImageTable = function SMImageTable(props) {
  var loading = props.loading,
    dataSource = props.dataSource,
    totalCount = props.totalCount,
    _props$current = props.current,
    current = _props$current === void 0 ? 1 : _props$current,
    _props$pageSize = props.pageSize,
    pageSize = _props$pageSize === void 0 ? 10 : _props$pageSize,
    _props$pageSizeOption = props.pageSizeOptions,
    pageSizeOptions = _props$pageSizeOption === void 0 ? ['10', '20', '50', '100'] : _props$pageSizeOption,
    rowSelection = props.rowSelection,
    isHidePagination = props.isHidePagination,
    _props$idName = props.idName,
    idName = _props$idName === void 0 ? 'id' : _props$idName,
    wrapperStyle = props.wrapperStyle,
    _props$imgWidth = props.imgWidth,
    imgWidth = _props$imgWidth === void 0 ? '100%' : _props$imgWidth,
    imgHeight = props.imgHeight,
    renderItem = props.renderItem,
    _props$rowNum = props.rowNum,
    rowNum = _props$rowNum === void 0 ? 4 : _props$rowNum,
    onSearch = props.onSearch,
    antdPaginationProps = props.antdPaginationProps,
    extraDom = props.extraDom,
    selectionExtraDom = props.selectionExtraDom;
  var handleTableChange = useCallback(function (current, pageSize) {
    onSearch && onSearch(current, pageSize);
  }, [onSearch]);
  var checkAllChangeHandle = useCallback(function (checked) {
    if (checked) {
      var checkedList = dataSource.map(function (val) {
        return val[idName];
      });
      rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.onChange(checkedList);
    } else {
      rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.onChange([]);
    }
  }, [dataSource, idName, rowSelection]);
  var getOperatorTpl = useCallback(function () {
    if (!selectionExtraDom && !extraDom) {
      return null;
    }
    return React.createElement("div", {
      className: styles$4.operator
    }, selectionExtraDom && rowSelection && React.createElement(BatchOperationBar, {
      selectionExtraDom: selectionExtraDom,
      selectLength: rowSelection.selectedRowKeys.length,
      totalCount: totalCount,
      currentTotalCount: dataSource.length,
      onCheckAllChange: function onCheckAllChange(e) {
        return checkAllChangeHandle(e.target.checked);
      }
    }), extraDom && React.createElement("div", {
      style: {
        flex: selectionExtraDom ? 'none' : 'auto'
      },
      className: styles$4['operator-wrapper']
    }, extraDom));
  }, [checkAllChangeHandle, dataSource.length, extraDom, rowSelection, selectionExtraDom, totalCount]);
  var operatorTpl = getOperatorTpl();
  return React.createElement(ConfigProvider, {
    locale: locale
  }, React.createElement("div", {
    style: wrapperStyle,
    className: styles$4['sm-imgtable-wrapper']
  }, operatorTpl, React.createElement("div", {
    className: styles$4['imgtable-wrapper']
  }, loading ? React.createElement("div", {
    className: styles$4['imgtable-wrapper-loading']
  }, React.createElement(IconLoading, null)) : dataSource.length ? React.createElement(TableCore, {
    dataSource: dataSource,
    allCheckList: rowSelection.selectedRowKeys,
    idName: idName,
    width: imgWidth,
    height: imgHeight,
    renderItem: renderItem,
    rowNum: rowNum,
    onSelectChange: rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.onChange
  }) : React.createElement(CustomizeRenderEmpty, null), !isHidePagination && React.createElement("div", {
    className: styles$4['sm-imgtable-pagination']
  }, React.createElement(Pagination, Object.assign({
    current: current,
    pageSize: pageSize,
    total: totalCount,
    pageSizeOptions: pageSizeOptions
  }, antdPaginationProps, {
    onChange: handleTableChange
  }))))));
};

var styles$6 = {"text-tag":"_3dHkd"};

var SMTextSection = function SMTextSection(props) {
  var text = props.text,
    caseId = props.caseId,
    labelList = props.labelList,
    tagStyle = props.tagStyle,
    currentTag = props.currentTag,
    onTagChange = props.onTagChange;
  var _useState = useState(''),
    showHtml = _useState[0],
    setShowHtml = _useState[1];
  var _useState2 = useState(''),
    showText = _useState2[0],
    setShowText = _useState2[1];
  var _useState3 = useState([]),
    tagList = _useState3[0],
    setTagList = _useState3[1];

  var cancelCallout = function cancelCallout(list) {
    try {
      if (!list.length) {
        return Promise.resolve();
      }
      var newHtml = showHtml;
      var newTagList = tagList;
      list.map(function (val) {
        var startOffset = val.startOffset,
          endOffset = val.endOffset;
        var textReg = new RegExp('<span id="' + (caseId + "-tag-" + startOffset + "-" + endOffset) + '".*<i id="' + (caseId + "-delete-" + startOffset + "-" + endOffset) + '"></i></span>', 'gim');
        if (textReg.test(newHtml)) {
          var dom = '';
          for (var i = startOffset; i <= endOffset; i++) {
            dom = dom + "<span id=\"" + (caseId + '-text-' + i) + "\">" + showText[i] + "</span>";
          }
          newHtml = newHtml.replace(textReg, dom);
          var deldetIndex = newTagList.findIndex(function (val) {
            return val.startOffset === startOffset && val.endOffset === endOffset;
          });
          if (deldetIndex !== -1) {
            newTagList.splice(deldetIndex, 1);
          }
        }
      });
      setShowHtml(newHtml);
      setTagList(newTagList);
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var callout = useCallback(function (list) {
    try {
      if (!list.length) {
        return Promise.resolve();
      }
      var newHtml = showHtml;
      var newTagList = tagList;
      list.map(function (val) {
        var startOffset = val.startOffset,
          endOffset = val.endOffset;
        var regText = startOffset === endOffset ? '<span id="' + (caseId + "-text-" + endOffset) + '">.?</span>' : '<span id="' + (caseId + "-text-" + startOffset) + '.*' + '<span id="' + (caseId + "-text-" + endOffset) + '">.?</span>';
        var textReg = new RegExp(regText, 'gim');
        if (textReg.test(newHtml)) {
          newHtml = newHtml.replace(textReg, "<span id=\"" + (caseId + '-tag-' + startOffset + '-' + endOffset) + "\" style=\"user-select: none;\" class=" + (tagStyle || styles$6['text-tag']) + ">" + showText.substring(startOffset, endOffset + 1) + "<span>" + currentTag + "</span><i id=\"" + (caseId + '-delete-' + startOffset + '-' + endOffset) + "\"></i></span>");
          newTagList.push({
            startOffset: startOffset,
            endOffset: endOffset
          });
        }
      });
      setShowHtml(newHtml);
      setTagList(newTagList);
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  }, [caseId, currentTag, showHtml, showText, tagList, tagStyle]);

  var selectText = function selectText(section) {
    if (!section) {
      return;
    }
    if (section.type === 'Range') {
      var baseId = Number(section.baseNode.parentNode.id.replace(caseId + "-text-", ''));
      var focusId = Number(section.focusNode.parentNode.id.replace(caseId + "-text-", ''));
      callout([{
        startOffset: baseId >= focusId ? focusId : baseId,
        endOffset: baseId >= focusId ? baseId : focusId
      }]);
    }
  };
  useEffect(function () {
    onTagChange(tagList);
  }, [onTagChange, tagList, tagList.length]);

  useEffect(function () {
    var dom = '';
    for (var i = 0; i < text.length - 1; i++) {
      dom = dom + "<span id=\"" + (caseId + '-text-' + i) + "\">" + text[i] + "</span>";
    }
    setShowHtml(dom);
    setShowText(text);
  }, [caseId, text]);

  useEffect(function () {
    if (showText && labelList) {
      callout(labelList);
    }
  }, [callout, labelList, showText]);

  var eventDelegationHandle = function eventDelegationHandle(e) {
    if (e.target.id.search('-delete-') !== -1) {
      var startOffset = Number(e.target.id.split('-')[2]);
      var endOffset = Number(e.target.id.split('-')[3]);
      cancelCallout([{
        startOffset: startOffset,
        endOffset: endOffset
      }]);
    }
  };
  return /*#__PURE__*/React.createElement("p", {
    id: "SMTextSection-" + caseId,
    onMouseUp: function onMouseUp() {
      selectText(window.getSelection && window.getSelection());
    },
    onClick: eventDelegationHandle,
    dangerouslySetInnerHTML: {
      __html: showHtml
    }
  });
};

var _excluded$2 = ["data", "labelName", "valueName", "isAddAll", "renderCustomLabel"];
var Option = Select.Option;
var SMSelect = function SMSelect(props) {
  var _props$data = props.data,
    data = _props$data === void 0 ? [] : _props$data,
    _props$labelName = props.labelName,
    labelName = _props$labelName === void 0 ? 'label' : _props$labelName,
    _props$valueName = props.valueName,
    valueName = _props$valueName === void 0 ? 'value' : _props$valueName,
    isAddAll = props.isAddAll,
    renderCustomLabel = props.renderCustomLabel,
    rest = _objectWithoutPropertiesLoose(props, _excluded$2);
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  console.log(data, '-=0=0=-');
  return React.createElement("div", null, React.createElement(Select, Object.assign({}, rest), isAddAll && React.createElement(Option, {
    key: "all",
    value: "all"
  }, t('全部')), data.map(function (item) {
    return React.createElement(Option, {
      key: item[valueName],
      value: item[valueName],
      title: item[labelName],
      disabled: item.disabled
    }, renderCustomLabel ? renderCustomLabel(item) : item[labelName] || '');
  })));
};

var formItemLayout = {
  labelCol: {
    xs: {
      span: 24
    },
    sm: {
      span: 8
    }
  },
  wrapperCol: {
    xs: {
      span: 24
    },
    sm: {
      span: 16
    }
  }
};
var formItemType = {
  CUSTOM: 'custom',
  INSERTDOM: 'insertDom',
  INPUT: 'input',
  INPUTNUMBER: 'inputNumber',
  SELECT: 'select',
  TEXTAREA: 'textarea',
  RANGEPICKER: 'rangePicker',
  DATEPICKER: 'datePicker',
  RADIO: 'radio',
  CHECKBOX: 'checkbox',
  CASCADER: 'cascader',
  UPLOADFILE: 'uploadFile'
};

var LabelItemTool = function LabelItemTool(props) {
  var label = props.label,
    help = props.help;
  return React.createElement("span", null, label, "\xA0", help ? React.createElement(Tooltip, {
    title: help
  }, React.createElement(QuestionCircleOutlined, null)) : null);
};

var styles$7 = {"sm-upload-wrapper":"_3BE9s"};

var SMUpload = function SMUpload(props) {
  var children = props.children,
    fileType = props.fileType,
    _props$fileList = props.fileList,
    fileList = _props$fileList === void 0 ? [] : _props$fileList,
    _props$maxCount = props.maxCount,
    maxCount = _props$maxCount === void 0 ? 100 : _props$maxCount,
    _props$buttonText = props.buttonText,
    buttonText = _props$buttonText === void 0 ? '点击上传' : _props$buttonText,
    _props$buttonProps = props.buttonProps,
    buttonProps = _props$buttonProps === void 0 ? {} : _props$buttonProps,
    previewRender = props.previewRender;
  var _useState = useState(false),
    previewVisible = _useState[0],
    setPreviewVisible = _useState[1];
  var _useState2 = useState(''),
    previewUrl = _useState2[0],
    setPreviewUrl = _useState2[1];
  var handlePreview = useCallback(function (file) {
    try {
      var _temp3 = function _temp3() {
        setPreviewVisible(true);
        setPreviewUrl(file.url || file.preview);
      };
      var _temp4 = function () {
        if (!file.url && !file.preview) {
          return Promise.resolve(getBase64(file.originFileObj)).then(function (_getBase) {
            file.preview = _getBase;
          });
        }
      }();
      return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4));
    } catch (e) {
      return Promise.reject(e);
    }
  }, []);
  var uploadButton = useMemo(function () {
    if (children !== undefined) {
      return children;
    }
    var showText = fileType === "audio" ? '上传音频' : buttonText;
    if (fileType === "image") {
      return fileList.length >= maxCount ? '' : showText;
    }
    return React.createElement(Button, Object.assign({
      type: "primary"
    }, buttonProps), showText);
  }, [children, maxCount, fileType, fileList.length, buttonProps, buttonText]);
  var handleCancel = useCallback(function () {
    return setPreviewVisible(false);
  }, []);
  return React.createElement("div", {
    className: styles$7['sm-upload-wrapper']
  }, React.createElement(Upload, Object.assign({
    directory: false,
    multiple: true,
    listType: "picture-card",
    showUploadList: {
      showDownloadIcon: false
    },
    onPreview: fileType === "image" ? handlePreview : undefined
  }, props), uploadButton), React.createElement(Modal, {
    visible: previewVisible,
    footer: null,
    onCancel: handleCancel
  }, previewRender ? previewRender(previewUrl) : React.createElement("img", {
    style: {
      width: '100%'
    },
    src: previewUrl
  })));
};

var styles$8 = {"sm-form-wrapper":"_1mYjQ","button-wrapper":"_PXux3"};

var RangePicker = DatePicker.RangePicker;
var FormItem = Form.Item;
var TextArea = Input.TextArea;
var RadioGroup = Radio.Group;
var CheckboxGroup = Checkbox.Group;
var SMForm = function SMForm(props) {
  var initialValues = props.initialValues,
    formProps = props.formProps,
    formData = props.formData,
    _props$isShowSubmitBt = props.isShowSubmitBtn,
    isShowSubmitBtn = _props$isShowSubmitBt === void 0 ? false : _props$isShowSubmitBt,
    isSubmit = props.isSubmit,
    _props$submitText = props.submitText,
    submitText = _props$submitText === void 0 ? '提交' : _props$submitText,
    _props$cancelText = props.cancelText,
    cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
    _props$submitWrapperS = props.submitWrapperStyle,
    submitWrapperStyle = _props$submitWrapperS === void 0 ? {} : _props$submitWrapperS,
    onCancel = props.onCancel,
    itemWidth = props.itemWidth,
    onSubmit = props.onSubmit,
    setForm = props.setForm;
  var hasSetForm = useRef(false);
  var formRef = useRef();
  var onFinish = useCallback(function (values) {
    onSubmit && onSubmit(values);
  }, [onSubmit]);
  var getRadioCheckOptions = useCallback(function (originData, labelName, valueName, rowNum, itemType) {
    return React.createElement(Row, null, originData.map(function (item) {
      return React.createElement(Col, {
        span: Math.ceil(24 / rowNum),
        key: item[valueName]
      }, itemType === formItemType.RADIO ? React.createElement(Radio, {
        key: item[valueName],
        value: item[valueName],
        disabled: item.disabled
      }, item[labelName]) : React.createElement(Checkbox, {
        key: item[valueName],
        value: item[valueName],
        disabled: item.disabled
      }, item[labelName]));
    }));
  }, []);
  var _renderCustomLabel = useCallback(function (item, isShowValue, labelName, valueName) {
    return item[labelName] + " " + (isShowValue ? item[valueName] : '');
  }, []);
  var getFormItems = useCallback(function () {
    var formItems = [];
    formData.forEach(function (item) {
      var type = item.type,
        label = item.label,
        placeholder = item.placeholder,
        help = item.help,
        definition = item.definition,
        onChange = item.onChange,
        _item$required = item.required,
        required = _item$required === void 0 ? false : _item$required,
        _item$disabled = item.disabled,
        disabled = _item$disabled === void 0 ? false : _item$disabled,
        customDom = item.customDom;
      var newCustomDom = _.isFunction(customDom) ? customDom() : customDom;
      var varId = definition["var"],
        _definition$condiates = definition.condiates,
        condiates = _definition$condiates === void 0 ? [] : _definition$condiates,
        _definition$labelName = definition.labelName,
        labelName = _definition$labelName === void 0 ? 'name' : _definition$labelName,
        _definition$valueName = definition.valueName,
        valueName = _definition$valueName === void 0 ? 'id' : _definition$valueName,
        _definition$childrenN = definition.childrenName,
        childrenName = _definition$childrenN === void 0 ? 'children' : _definition$childrenN,
        _definition$uploadOpt = definition.uploadOptions,
        uploadOptions = _definition$uploadOpt === void 0 ? {} : _definition$uploadOpt,
        _definition$isAddAll = definition.isAddAll,
        isAddAll = _definition$isAddAll === void 0 ? false : _definition$isAddAll,
        _definition$component = definition.componentProps,
        componentProps = _definition$component === void 0 ? {} : _definition$component,
        _definition$validator = definition.validator,
        validator = _definition$validator === void 0 ? null : _definition$validator,
        _definition$customsty = definition.customstyle,
        customstyle = _definition$customsty === void 0 ? {} : _definition$customsty,
        _definition$formItemP = definition.formItemProps,
        formItemProps = _definition$formItemP === void 0 ? {} : _definition$formItemP,
        _definition$rowNum = definition.rowNum,
        rowNum = _definition$rowNum === void 0 ? 3 : _definition$rowNum,
        _definition$isShowVal = definition.isShowValue,
        isShowValue = _definition$isShowVal === void 0 ? false : _definition$isShowVal;
      var itemStyle = _extends({
        width: itemWidth || '70%'
      }, customstyle);
      var formRules = [{
        required: required,
        message: placeholder
      }];
      if (validator && !formRules[1]) {
        formRules.push({
          validator: validator
        });
      }
      var formItem = null;
      var allFormItemProps = _extends({
        label: label || help ? React.createElement(LabelItemTool, {
          label: label,
          help: help
        }) : null,
        name: varId,
        key: varId,
        rules: formRules
      }, formItemProps);
      switch (type) {
        case formItemType.CUSTOM:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), newCustomDom);
          break;
        case formItemType.INSERTDOM:
          formItem = newCustomDom;
          break;
        case formItemType.INPUT:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(Input, Object.assign({}, componentProps, {
            autoComplete: "off",
            placeholder: placeholder,
            disabled: disabled,
            style: itemStyle,
            onChange: onChange
          })));
          break;
        case formItemType.INPUTNUMBER:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(InputNumber, Object.assign({}, componentProps, {
            placeholder: placeholder,
            disabled: disabled,
            style: itemStyle,
            onChange: onChange
          })));
          break;
        case formItemType.SELECT:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(SMSelect, Object.assign({}, componentProps, {
            style: itemStyle,
            isAddAll: isAddAll,
            labelName: labelName,
            valueName: valueName,
            data: condiates,
            showSearch: true,
            optionFilterProp: "children",
            placeholder: placeholder,
            disabled: disabled,
            renderCustomLabel: function renderCustomLabel(item) {
              return _renderCustomLabel(item, isShowValue, labelName, valueName);
            },
            onChange: onChange
          })));
          break;
        case formItemType.TEXTAREA:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(TextArea, Object.assign({}, componentProps, {
            autoComplete: "off",
            placeholder: placeholder,
            disabled: disabled,
            style: itemStyle,
            onChange: onChange
          })));
          break;
        case formItemType.RANGEPICKER:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(RangePicker, Object.assign({}, componentProps, {
            showTime: {
              defaultValue: [moment('00:00:00', 'HH:mm:ss'), moment('23:59:59', 'HH:mm:ss')]
            },
            style: itemStyle,
            disabled: disabled,
            onChange: onChange
          })));
          break;
        case formItemType.DATEPICKER:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(DatePicker, Object.assign({}, componentProps, {
            style: itemStyle,
            disabled: disabled,
            onChange: onChange
          })));
          break;
        case formItemType.RADIO:
          var radioTpl = getRadioCheckOptions(condiates, labelName, valueName, rowNum, type);
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(RadioGroup, Object.assign({}, componentProps, {
            disabled: disabled,
            style: itemStyle,
            onChange: onChange
          }), radioTpl));
          break;
        case formItemType.CHECKBOX:
          var checkboxTpl = getRadioCheckOptions(condiates, labelName, valueName, rowNum, type);
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(CheckboxGroup, Object.assign({}, componentProps, {
            disabled: disabled,
            style: itemStyle,
            onChange: onChange
          }), checkboxTpl));
          break;
        case formItemType.CASCADER:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(Cascader, Object.assign({}, componentProps, {
            style: itemStyle,
            showSearch: true,
            options: condiates,
            placeholder: placeholder,
            disabled: disabled,
            fieldNames: {
              label: labelName || 'label',
              value: valueName || 'value',
              children: childrenName || 'children'
            },
            onChange: onChange
          })));
          break;
        case formItemType.UPLOADFILE:
          formItem = React.createElement(FormItem, Object.assign({}, allFormItemProps), React.createElement(SMUpload, Object.assign({
            style: itemStyle
          }, uploadOptions)));
          break;
      }
      formItems.push(formItem);
    });
    if (isShowSubmitBtn || onCancel) {
      formItems.push(React.createElement("div", {
        key: "submit-button",
        className: styles$8['button-wrapper'],
        style: submitWrapperStyle
      }, onCancel && React.createElement(Button, {
        type: "ghost",
        onClick: onCancel
      }, cancelText), isShowSubmitBtn && React.createElement(Button, {
        type: "primary",
        loading: isSubmit,
        disabled: isSubmit,
        htmlType: "submit"
      }, submitText)));
    }
    return formItems;
  }, [cancelText, formData, getRadioCheckOptions, isShowSubmitBtn, isSubmit, itemWidth, onCancel, _renderCustomLabel, submitText, submitWrapperStyle]);
  useLayoutEffect(function () {
    if (setForm && formRef.current && !hasSetForm.current) {
      setForm(formRef.current);
      hasSetForm.current = true;
    }
  }, [setForm]);
  return React.createElement("div", {
    className: styles$8['sm-form-wrapper']
  }, React.createElement(ConfigProvider, {
    locale: locale
  }, React.createElement(Form, Object.assign({
    ref: formRef,
    initialValues: initialValues
  }, formItemLayout, formProps, {
    onFinish: onFinish
  }), getFormItems())));
};

var styles$9 = {"sm-form-wrapper":"_2Mfou","button-wrapper":"_1dlwi"};

var LabelItem = function LabelItem(props) {
  var label = props.label,
    help = props.help;
  var toolTipTpl = help ? /*#__PURE__*/React.createElement(Tooltip, {
    title: help
  }, /*#__PURE__*/React.createElement(QuestionCircleOutlined, null)) : null;
  return /*#__PURE__*/React.createElement("span", null, label, "\xA0", toolTipTpl);
};

var _excluded$3 = ["condiates", "labelName", "valueName", "itemStyle", "defaultValue", "onChange", "allObj", "value", "placeholder", "disabled", "isAddAll"];
var Option$1 = Select.Option;
var SMMultipleSelect = function SMMultipleSelect(props) {
  var _ref;
  var _props$condiates = props.condiates,
    condiates = _props$condiates === void 0 ? [] : _props$condiates,
    _props$labelName = props.labelName,
    labelName = _props$labelName === void 0 ? 'label' : _props$labelName,
    _props$valueName = props.valueName,
    valueName = _props$valueName === void 0 ? 'value' : _props$valueName,
    _props$itemStyle = props.itemStyle,
    itemStyle = _props$itemStyle === void 0 ? (_ref = {}, _ref[labelName] = '全部', _ref[valueName] = 'ALL', _ref) : _props$itemStyle,
    _props$defaultValue = props.defaultValue,
    defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
    onChange = props.onChange,
    _props$allObj = props.allObj,
    allObj = _props$allObj === void 0 ? {} : _props$allObj,
    placeholder = props.placeholder,
    disabled = props.disabled,
    isAddAll = props.isAddAll,
    rest = _objectWithoutPropertiesLoose(props, _excluded$3);
  var newCondiates = isAddAll ? [allObj].concat(condiates) : condiates;
  var getAllData = useCallback(function () {
    return _.map(newCondiates, function (item) {
      return item[valueName];
    }).filter(function (item) {
      return item !== allObj[valueName];
    });
  }, [allObj, newCondiates, valueName]);
  var _useState = useState(defaultValue.includes(allObj[valueName]) ? getAllData() : defaultValue),
    selectValue = _useState[0],
    setSelectValue = _useState[1];
  var maxTagPlaceholder = useCallback(function () {
    return React.createElement("div", null, allObj[labelName]);
  }, [allObj, labelName]);
  var getSelectOption = useMemo(function () {
    var isExistAll = _.some(newCondiates, function (item) {
      return item[labelName] === allObj[labelName];
    });
    if (isExistAll && selectValue.length === getAllData().length) {
      return {
        maxTagCount: 0,
        maxTagPlaceholder: maxTagPlaceholder
      };
    }
    return {};
  }, [selectValue, maxTagPlaceholder, getAllData]);
  var getValue = useCallback(function (val) {
    if (val.includes(allObj[valueName])) {
      return selectValue.length === getAllData().length ? [] : getAllData();
    }
    return val;
  }, [allObj, selectValue, valueName, getAllData]);
  var handleChange = useCallback(function (val) {
    var newValue = getValue(val);
    setSelectValue(newValue);
    onChange && onChange(newValue);
  }, [onChange, getValue]);
  return React.createElement("div", null, React.createElement(Select, Object.assign({
    mode: "multiple",
    style: itemStyle,
    disabled: disabled,
    value: selectValue,
    placeholder: placeholder,
    onChange: handleChange
  }, getSelectOption, rest), _.map(newCondiates, function (item) {
    return React.createElement(Option$1, {
      key: item[valueName],
      value: item[valueName],
      title: item[labelName]
    }, item[labelName]);
  })));
};

var _dec, _class;
var Option$2 = Select.Option;
var RangePicker$1 = DatePicker.RangePicker;
var FormItem$1 = Form.Item;
var TextArea$1 = Input.TextArea;
var RadioGroup$1 = Radio.Group;
var CheckboxGroup$1 = Checkbox.Group;
var SMForm$1 = (_dec = withTranslation(), _dec(_class = /*#__PURE__*/function (_Component) {
  _inheritsLoose(SMForm, _Component);
  function SMForm(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.componentDidMount = function () {
      var setForm = _this.props.setForm;
      setForm && _this.formRef.current && setForm(_this.formRef.current);

    };
    _this.componentWillReceiveProps = function () {
    };
    _this.onFinish = function (values) {
      var onSubmit = _this.props.onSubmit;
      onSubmit && onSubmit(values);
    };
    _this.getOptions = function (originData, labelName, valueName, isAddAll, isShowValue, otherLabelName) {
      var t = _this.props.t;
      var options = [];
      if (isAddAll) {
        options.push( /*#__PURE__*/React.createElement(Option$2, {
          key: "all-1",
          value: "all"
        }, t('全部')));
      }
      originData.map(function (item) {
        options.push( /*#__PURE__*/React.createElement(Option$2, {
          key: item[valueName],
          value: item[valueName],
          disabled: item.disabled,
          title: item[labelName]
        }, item[labelName], isShowValue && "(" + (item[otherLabelName] || item[valueName]) + ")"));
      });
      return options;
    };
    _this.getRadioOptions = function (originData, labelName, valueName, rowNum) {
      var showNum = Math.ceil(24 / rowNum);
      return /*#__PURE__*/React.createElement(Row, null, originData.map(function (item) {
        return /*#__PURE__*/React.createElement(Col, {
          span: showNum,
          key: item[valueName]
        }, /*#__PURE__*/React.createElement(Radio, {
          value: item[valueName]
        }, item[labelName]));
      }));
    };
    _this.getCheckboxOptions = function (originData, labelName, valueName, rowNum) {
      var showNum = Math.ceil(24 / rowNum);
      return /*#__PURE__*/React.createElement(Row, null, originData.map(function (item) {
        return /*#__PURE__*/React.createElement(Col, {
          span: showNum,
          key: item[valueName]
        }, /*#__PURE__*/React.createElement(Checkbox, {
          key: item[valueName],
          value: item[valueName]
        }, item[labelName]));
      }));
    };
    _this.getFormItems = function () {
      var _this$props = _this.props,
        formData = _this$props.formData,
        _this$props$isShowSub = _this$props.isShowSubmitBtn,
        isShowSubmitBtn = _this$props$isShowSub === void 0 ? false : _this$props$isShowSub,
        isSubmit = _this$props.isSubmit,
        _this$props$submitTex = _this$props.submitText,
        submitText = _this$props$submitTex === void 0 ? '提交' : _this$props$submitTex,
        _this$props$cancelTex = _this$props.cancelText,
        cancelText = _this$props$cancelTex === void 0 ? '取消' : _this$props$cancelTex,
        _this$props$submitWra = _this$props.submitWrapperStyle,
        submitWrapperStyle = _this$props$submitWra === void 0 ? {} : _this$props$submitWra,
        onCancel = _this$props.onCancel,
        itemWidth = _this$props.itemWidth;
      var formItems = [];
      formData.forEach(function (item) {
        var type = item.type,
          label = item.label,
          placeholder = item.placeholder,
          help = item.help,
          definition = item.definition,
          _item$onChange = item.onChange,
          onChange = _item$onChange === void 0 ? null : _item$onChange,
          _item$required = item.required,
          required = _item$required === void 0 ? false : _item$required,
          _item$disabled = item.disabled,
          disabled = _item$disabled === void 0 ? false : _item$disabled,
          customDom = item.customDom,
          hidden = item.hidden;
        if (hidden) {
          return;
        }

        var newCustomDom = _.isFunction(customDom) ? customDom() : customDom;
        var varId = definition["var"],
          _definition$condiates = definition.condiates,
          condiates = _definition$condiates === void 0 ? [] : _definition$condiates,
          _definition$labelName = definition.labelName,
          labelName = _definition$labelName === void 0 ? 'name' : _definition$labelName,
          _definition$valueName = definition.valueName,
          valueName = _definition$valueName === void 0 ? 'id' : _definition$valueName,
          _definition$childrenN = definition.childrenName,
          childrenName = _definition$childrenN === void 0 ? 'children' : _definition$childrenN,
          _definition$uploadOpt = definition.uploadOptions,
          uploadOptions = _definition$uploadOpt === void 0 ? {} : _definition$uploadOpt,
          _definition$isAddAll = definition.isAddAll,
          isAddAll = _definition$isAddAll === void 0 ? false : _definition$isAddAll,
          _definition$component = definition.componentProps,
          componentProps = _definition$component === void 0 ? {} : _definition$component,
          _definition$validator = definition.validator,
          validator = _definition$validator === void 0 ? null : _definition$validator,
          _definition$customsty = definition.customstyle,
          customstyle = _definition$customsty === void 0 ? {} : _definition$customsty,
          _definition$formItemP = definition.formItemProps,
          formItemProps = _definition$formItemP === void 0 ? {} : _definition$formItemP,
          _definition$rowNum = definition.rowNum,
          rowNum = _definition$rowNum === void 0 ? 3 : _definition$rowNum,
          _definition$isShowVal = definition.isShowValue,
          isShowValue = _definition$isShowVal === void 0 ? false : _definition$isShowVal,
          _definition$otherLabe = definition.otherLabelName,
          otherLabelName = _definition$otherLabe === void 0 ? false : _definition$otherLabe;
        var itemStyle = _extends({
          width: itemWidth || '70%'
        }, customstyle);

        var formRules = [{
          required: required,
          message: placeholder
        }];
        if (validator && !formRules[1]) {
          formRules.push({
            validator: validator
          });
        }
        var formItem = null;
        var allFormItemProps = _extends({
          label: label || help ? /*#__PURE__*/React.createElement(LabelItem, {
            label: label,
            help: help
          }) : null,
          name: varId,
          key: varId,
          rules: formRules
        }, formItemProps);
        switch (type) {
          case 'custom':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, newCustomDom);
            break;
          case 'insertDom':
            formItem = newCustomDom;
            break;
          case 'input':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(Input, _extends({
              autoComplete: "off",
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled,
              style: itemStyle
            }, componentProps)));
            break;
          case 'inputNumber':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(InputNumber, _extends({
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled,
              style: itemStyle
            }, componentProps)));
            break;
          case 'select':
            var selectOptionTpl = _this.getOptions(condiates, labelName, valueName, isAddAll, isShowValue, otherLabelName);
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(Select, _extends({
              style: itemStyle,
              showSearch: true,
              optionFilterProp: "children",
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled
            }, componentProps), selectOptionTpl));
            break;
          case 'multipleSelect':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(SMMultipleSelect, _extends({
              isAddAll: isAddAll,
              itemStyle: itemStyle,
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled
            }, definition, componentProps)));
            break;
          case 'textarea':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(TextArea$1, _extends({
              autoComplete: "off",
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled,
              style: itemStyle
            }, componentProps)));
            break;
          case 'rangePicker':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(RangePicker$1, _extends({
              showTime: {
                defaultValue: [moment('00:00:00', 'HH:mm:ss'), moment('23:59:59', 'HH:mm:ss')]
              },
              style: itemStyle,
              onChange: onChange,
              disabled: disabled
            }, componentProps)));
            break;
          case 'datePicker':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(DatePicker, _extends({
              style: itemStyle,
              onChange: onChange,
              disabled: disabled
            }, componentProps)));
            break;
          case 'radio':
            var radioTpl = _this.getRadioOptions(condiates, labelName, valueName, rowNum);
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(RadioGroup$1, _extends({
              onChange: onChange,
              disabled: disabled,
              style: itemStyle
            }, componentProps), radioTpl));
            break;
          case 'checkbox':
            var checkboxTpl = _this.getCheckboxOptions(condiates, labelName, valueName, rowNum);
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(CheckboxGroup$1, _extends({
              onChange: onChange,
              disabled: disabled,
              style: itemStyle
            }, componentProps), checkboxTpl));
            break;
          case 'cascader':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(Cascader, _extends({
              style: itemStyle,
              showSearch: {
                limit: 1000
              },
              options: condiates,
              placeholder: placeholder,
              onChange: onChange,
              disabled: disabled,
              fieldNames: {
                label: labelName || 'label',
                value: valueName || 'value',
                children: childrenName || 'children'
              }
            }, componentProps)));
            break;
          case 'uploadFile':
            formItem = /*#__PURE__*/React.createElement(FormItem$1, allFormItemProps, /*#__PURE__*/React.createElement(SMUpload, _extends({
              style: itemStyle
            }, uploadOptions)));
            break;
        }
        formItems.push(formItem);
      });

      if (isShowSubmitBtn || onCancel) {
        formItems.push( /*#__PURE__*/React.createElement("div", {
          key: "submit-button",
          className: styles$9['button-wrapper'],
          style: submitWrapperStyle
        }, onCancel && /*#__PURE__*/React.createElement(Button, {
          type: "ghost",
          onClick: onCancel
        }, cancelText), isShowSubmitBtn && /*#__PURE__*/React.createElement(Button, {
          type: "primary",
          loading: isSubmit,
          disabled: isSubmit,
          htmlType: "submit"
        }, submitText)));
      }
      return formItems;
    };
    _this.formRef = React.createRef();
    return _this;
  }
  var _proto = SMForm.prototype;
  _proto.render = function render() {
    var _this$props2 = this.props,
      initialValues = _this$props2.initialValues,
      formProps = _this$props2.formProps;
    var formItems = this.getFormItems();
    var formItemLayout = {
      labelCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 8
        }
      },
      wrapperCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 16
        }
      }
    };
    return /*#__PURE__*/React.createElement("div", {
      className: styles$9['sm-form-wrapper']
    }, /*#__PURE__*/React.createElement(Form, _extends({
      ref: this.formRef,
      initialValues: initialValues,
      onFinish: this.onFinish
    }, formItemLayout, formProps), formItems));
  };
  return SMForm;
}(Component)) || _class);

var styles$a = {"btn-count":"_2kXs_","btn":"_2SXzh"};

var initDefaultValue = function initDefaultValue(val) {
  if (val) {
    if (typeof val === 'string') {
      return [val];
    }
    return val;
  }
  return [];
};

var getBtnDom = function getBtnDom(dataSource, definition, checkedList, disabled, mode, required, onChange, setCheckedList, antdProps) {
  var value = definition.labelValue;
  var name = definition.labelName;
  return dataSource.map(function (item) {
    var isExist = checkedList.indexOf(item[value]) > -1;
    return /*#__PURE__*/React.createElement(Button, _extends({
      key: item[name],
      type: isExist ? 'primary' : '',
      disabled: disabled || item.disabled,
      className: styles$a.btn,
      onClick: function onClick() {
        var newList = _.cloneDeep(checkedList);
        if (mode === 'multiple') {
          if (isExist) {
            if (required) {
              if (newList.length > 1) {
                var index = newList.indexOf(item[value]);
                if (index > -1) {
                  newList.splice(index, 1);
                }
              }
            } else {
              var _index = newList.indexOf(item[value]);
              if (_index > -1) {
                newList.splice(_index, 1);
              }
            }
          } else {
            newList.push(item[value]);
          }
          onChange(newList);
        } else {
          if (!required && isExist) {
            newList = [];
          } else {
            newList = [item[value]];
          }
          onChange(newList.length ? newList[0] : '');
        }
        setCheckedList(newList);
      }
    }, antdProps), item[name]);
  });
};

var SMTagSelect = function SMTagSelect(_ref) {
  var _ref$defaultValue = _ref.defaultValue,
    defaultValue = _ref$defaultValue === void 0 ? '' : _ref$defaultValue,
    _ref$definition = _ref.definition,
    definition = _ref$definition === void 0 ? {
      labelName: 'name',
      labelValue: 'value'
    } : _ref$definition,
    _ref$dataSource = _ref.dataSource,
    dataSource = _ref$dataSource === void 0 ? [] : _ref$dataSource,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    disabled = _ref.disabled,
    mode = _ref.mode,
    required = _ref.required,
    _ref$antdProps = _ref.antdProps,
    antdProps = _ref$antdProps === void 0 ? {} : _ref$antdProps;
  var _useState = useState(initDefaultValue(defaultValue)),
    checkedList = _useState[0],
    setCheckedList = _useState[1];
  useEffect(function () {
    setCheckedList(initDefaultValue(defaultValue));
  }, [defaultValue]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles$a['btn-count']
  }, getBtnDom(dataSource, definition, checkedList, disabled, mode, required, onChange, setCheckedList, antdProps));
};

var DATE_PICKER_TYPE = {
  START: 'startTime',
  END: 'endTime',
  SUBTRACT: 'subtract'
};
var DATE_TYPE = {
  DAY: 'day',
  WEEK: 'week',
  MONTH: 'month'
};
var FORMAT_STR = 'YYYY-MM-DD HH:mm:ss';

var styles$b = {"day-style":"_2Et0E","week-style":"_mCb0k","month-style":"_3BaXZ"};

var SMDatePicker = function SMDatePicker(props) {
  var setValue = props.setValue,
    formatStr = props.formatStr,
    dateType = props.dateType,
    onChange = props.onChange,
    componentProps = props.componentProps,
    weekCount = props.weekCount,
    fontInner = props.fontInner,
    customStyle = props.customStyle;
  var startRef = useRef(moment(setValue[0]).format(formatStr));
  var endRef = useRef(moment(setValue[1]).format(formatStr));
  var startDisabledDate = useCallback(function (current) {
    return current && current.diff(moment(endRef.current, formatStr), 'days') >= 0;
  }, [formatStr]);
  var endDisabledDate = useCallback(function (current) {
    return current && current.diff(moment(startRef.current, formatStr), 'days') <= 0;
  }, [formatStr]);
  var weekDisableDate = useCallback(function (current) {
    return current && current.diff(moment(moment().subtract(0, 'day').format(formatStr), formatStr), 'days') >= 0;
  }, [formatStr]);
  var handleDayChange = useCallback(function (__, timeString, type) {
    if (type === DATE_PICKER_TYPE.START) {
      startRef.current = timeString;
    } else {
      endRef.current = timeString;
    }
    onChange(startRef.current, endRef.current);
  }, [onChange]);
  var handleWeekChange = useCallback(function (__, timeString) {
    endRef.current = timeString;
    var startDate = weekCount[2] === DATE_PICKER_TYPE.SUBTRACT ? moment(endRef.current).subtract(weekCount[0], weekCount[1]).format(formatStr) : moment(endRef.current).add(weekCount[0], weekCount[1]).format(formatStr);
    startRef.current = startDate;
    onChange(startRef.current, endRef.current);
  }, [formatStr, onChange, weekCount]);
  var getDateDom = useCallback(function (type) {
    var format = !componentProps ? formatStr : componentProps.showTime && !!componentProps.showTime ? FORMAT_STR : formatStr;
    var value = type === DATE_PICKER_TYPE.START ? moment(startRef.current, formatStr) : moment(endRef.current, formatStr);
    var disableDate = type === DATE_PICKER_TYPE.START ? startDisabledDate : endDisabledDate;
    switch (dateType) {
      case DATE_TYPE.DAY:
        return React.createElement(DatePicker, Object.assign({
          className: styles$b['day-style'],
          disabledDate: disableDate,
          allowClear: false,
          value: value,
          format: format,
          onChange: function onChange(time, timeString) {
            return handleDayChange(time, timeString, type);
          }
        }, componentProps));
      case DATE_TYPE.WEEK:
        return React.createElement(DatePicker, Object.assign({
          allowClear: false,
          className: styles$b['week-style'],
          value: value,
          disabledDate: weekDisableDate,
          format: format,
          onChange: function onChange(time, timeString) {
            return handleWeekChange(time, timeString);
          }
        }, componentProps));
      case DATE_TYPE.MONTH:
        return React.createElement(DatePicker, Object.assign({
          className: styles$b['week-style'],
          allowClear: false,
          value: value,
          format: format,
          picker: dateType,
          onChange: function onChange(time, timeString) {
            return handleDayChange(time, timeString, type);
          }
        }, componentProps));
      default:
        return React.createElement(DatePicker, Object.assign({
          className: styles$b['day-style'],
          disabledDate: disableDate,
          allowClear: false,
          value: value,
          format: format,
          onChange: function onChange(time, timeString) {
            return handleDayChange(time, timeString, type);
          }
        }, componentProps));
    }
  }, [componentProps, dateType, endDisabledDate, formatStr, handleDayChange, handleWeekChange, startDisabledDate, weekDisableDate]);
  useEffect(function () {
    startRef.current = moment(setValue[0]).format(formatStr);
    endRef.current = moment(setValue[1]).format(formatStr);
  }, [formatStr, setValue]);
  return React.createElement(Fragment, null, dateType === DATE_TYPE.WEEK ? React.createElement("div", {
    style: customStyle ? customStyle : {
      width: '100%'
    }
  }, getDateDom(DATE_PICKER_TYPE.END)) : React.createElement("div", {
    style: customStyle ? customStyle : {
      width: '100%'
    }
  }, getDateDom(DATE_PICKER_TYPE.START), React.createElement("span", null, "\xA0", fontInner ? fontInner : '至', "\xA0"), getDateDom(DATE_PICKER_TYPE.END)));
};

var styles$c = {"count":"_2VZDi","function":"_2qc4G","play-img":"_1u_mw","footer-img":"_1gSLg","footer-left":"_aVV1j","footer-time":"_1WQYV","footer-right":"_1D6ik","footer-full":"_3mupf","backRate":"_1Z7PC","back-rate-title":"_23uuU","checked-li":"_UGH6A","function-full":"_39Qvq","multiple":"_3Jdon","broadcast":"_jqs1_"};

var BoFang = require("./bofang~ptnizMmy.png");

var ZanTing = require("./zanting~oiLVudvZ.png");

var Shenyin = require("./shenyin~HdZcufOP.png");

var JingYin = require("./jingyin~hmNbxlUV.png");

var QuanPin = require("./quanpin~kTrGKWtU.png");

var ShuoXiao = require("./shuoxiao~WXUTgqbI.png");

var Download = require("./xiazai~bhiXucfY.png");

var useInterval = function useInterval(callback, delay) {
  var savedCallback = useRef();
  useEffect(function () {
    savedCallback.current = callback;
  }, [callback]);
  useEffect(function () {
    function tick() {
      savedCallback.current();
    }
    if (delay !== null) {
      var id = setInterval(tick, delay);
      return function () {
        return clearInterval(id);
      };
    }
  }, [delay]);
};

var SMVideo = function SMVideo(props) {
  var src = props.src,
    id = props.id,
    _props$width = props.width,
    width = _props$width === void 0 ? 300 : _props$width,
    _props$height = props.height,
    height = _props$height === void 0 ? 400 : _props$height,
    _props$loop = props.loop,
    loop = _props$loop === void 0 ? false : _props$loop,
    play = props.play,
    hideOperation = props.hideOperation,
    _props$videoEle = props.videoEle,
    videoEle = _props$videoEle === void 0 ? false : _props$videoEle,
    hidePalyFlag = props.hidePalyFlag,
    hideBackFlag = props.hideBackFlag,
    hideTimeFlag = props.hideTimeFlag,
    hideVoiceFlag = props.hideVoiceFlag,
    hideFulllFlag = props.hideFulllFlag,
    hideDownloadFlag = props.hideDownloadFlag,
    hideSlideFlag = props.hideSlideFlag;
  var _useState = useState(true),
    isPlay = _useState[0],
    setIsPlay = _useState[1];
  var _useState2 = useState(0),
    currentTime = _useState2[0],
    setCurrentTime = _useState2[1];
  var _useState3 = useState(0),
    totalTime = _useState3[0],
    setTotalTime = _useState3[1];
  var _useState4 = useState(true),
    isError = _useState4[0],
    setIsError = _useState4[1];
  var _useState5 = useState(false),
    isBan = _useState5[0],
    setIsBan = _useState5[1];
  var _useState6 = useState(true),
    isFull = _useState6[0],
    setIsFull = _useState6[1];
  var _useState7 = useState('1.0'),
    checkedLi = _useState7[0],
    setChe = _useState7[1];
  var _useState8 = useState(width),
    newWidth = _useState8[0],
    setWidth = _useState8[1];
  var _useState9 = useState(height),
    newHeight = _useState9[0],
    setHeight = _useState9[1];
  var backRateList = ['2.0', '1.5', '1.25', '1.0', '0.75', '0.5'];
  useInterval(function () {
    var currentAudio = document.getElementById(id);
    setCurrentTime(parseInt(currentAudio.currentTime, 10) || 0);
  }, isPlay ? null : 300);
  useInterval(function () {
    var currentAudio = document.getElementById(id);
    setIsPlay(currentAudio.paused);
    setCurrentTime(parseInt(currentAudio.currentTime, 10) || 0);
  }, videoEle ? 300 : null);

  var onAudioLoad = useCallback(function () {
    var currentAudio = document.getElementById(id);
    if (currentAudio.readyState > 0) {
      var countDom = document.getElementById(id + "_count");
      var videoDom = document.getElementById("" + id);
      setTotalTime(parseInt(currentAudio.duration, 10));
      countDom.style.height = newHeight + 'px';
      countDom.style.width = newWidth + 'px';
      setIsError(false);
      if (play) {
        videoDom.play();
        setIsPlay(false);
      }
      videoEle && videoEle(currentAudio);
    }
  }, [id, newHeight, newWidth, play, videoEle]);
  var onAudioError = function onAudioError() {
    setIsError(true);
  };

  var onPlayEnded = function onPlayEnded() {
    setIsPlay(true);
  };
  var checkFull = function checkFull() {
    var isFull = document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement;
    if (isFull === undefined) {
      isFull = false;
    }
    return isFull;
  };

  var downloadFile = function downloadFile(url, fileName) {
    var x = new window.XMLHttpRequest();
    x.open('GET', url, true);
    x.responseType = 'blob';
    x.onload = function () {
      var url = window.URL.createObjectURL(x.response);
      var a = document.createElement('a');
      a.href = url;
      a.download = fileName;
      a.click();
    };
    x.send();
    x.onerror = function () {
      window.open(url);
    };
  };

  var fullScreen = function fullScreen() {
    var countDom = document.getElementById(id + "_count");
    setIsFull(false);
    var docElm = countDom;
    if (docElm.requestFullscreen) {
      docElm.requestFullscreen();
    } else if (docElm.msRequestFullscreen) {
      docElm.msRequestFullscreen();
    } else if (docElm.mozRequestFullScreen) {
      docElm.mozRequestFullScreen();
    } else if (docElm.webkitRequestFullScreen) {
      docElm.webkitRequestFullScreen();
    }
    var w = window.screen.availWidth || window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
    var h = window.screen.availHeight || window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    setWidth(w);
    setHeight(h);
    if (countDom) {
      countDom.style.width = w + 'px';
      countDom.style.height = h + 110 + 'px';
    }
  };

  var onClickPlay = function onClickPlay(type) {
    var videoDom = document.getElementById(id);
    switch (type) {
      case 'play':
        if (isPlay) {
          videoDom.play();
          if (videoDom.currentTime === totalTime) {
            setCurrentTime(0);
            videoDom.currentTime = 0;
          }
        } else {
          videoDom.pause();
        }
        setIsPlay(!isPlay);
        break;
      case 'voice':
        videoDom.muted = !isBan;
        setIsBan(!isBan);
        break;
      case 'full':
        if (isFull) {
          fullScreen();
        } else {
          exitFullscreen();
        }
        break;
    }
  };

  var exitFullscreen = useCallback(function (quit) {
    var countDom = document.getElementById(id + "_count");
    if (!quit) {
      if (document.exitFullscreen) {
        document.exitFullscreen();
      } else if (document.msExitFullscreen) {
        document.msExitFullscreen();
      } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
      } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
      }
    }
    setIsFull(true);
    setWidth(width);
    setHeight(height);
    if (countDom) {
      countDom.style.width = width + 'px';
      countDom.style.height = height + 'px';
    }
  }, [height, id, width]);

  var getPlaybackRateDom = function getPlaybackRateDom() {
    return /*#__PURE__*/React.createElement("div", {
      className: styles$c.backRate
    }, /*#__PURE__*/React.createElement("ul", {
      className: styles$c['back-rate-li']
    }, backRateList.map(function (item) {
      return /*#__PURE__*/React.createElement("li", {
        key: item,
        className: checkedLi === item ? styles$c['checked-li'] : styles$c[''],
        onClick: function onClick() {
          setChe(item);
          document.getElementById("" + id).playbackRate = item;
        }
      }, item, "x");
    })), /*#__PURE__*/React.createElement("p", {
      className: styles$c['back-rate-title']
    }, "\u500D\u901F"));
  };

  var getSlider = function getSlider() {
    return /*#__PURE__*/React.createElement(Slider, {
      value: currentTime,
      tipFormatter: function tipFormatter(val) {
        return formatTime(val);
      },
      max: totalTime,
      min: 0
      ,
      onChange: function onChange(val) {
        var currentAudio = document.getElementById(id);
        setCurrentTime(val);
        currentAudio.currentTime = val;
      }
    });
  };
  useEffect(function () {
    var currentAudio = document.getElementById(id);
    if (currentAudio) {
      currentAudio.addEventListener('canplay', onAudioLoad);
      currentAudio.addEventListener('ended', onPlayEnded);
      currentAudio.addEventListener('error', onAudioError);
      window.addEventListener('resize', function () {
        if (!checkFull()) {
          exitFullscreen('quit');
        }
      });
    }
    return function () {
      if (currentAudio) {
        currentAudio.removeEventListener('canplay', onAudioLoad);
        currentAudio.removeEventListener('ended', onPlayEnded);
        currentAudio.removeEventListener('error', onAudioError);
      }
    };
  }, [exitFullscreen, id, onAudioLoad]);
  return /*#__PURE__*/React.createElement("div", {
    id: id + "_count",
    className: "" + styles$c.count
  }, /*#__PURE__*/React.createElement("video", {
    id: id,
    src: src,
    width: newWidth,
    height: newHeight - 20,
    loop: loop
    ,
    autoPlay: false
  }, "\u60A8\u7684\u6D4F\u89C8\u5668\u4E0D\u652F\u6301 video \u6807\u7B7E\u3002"), !isError && !hideOperation ? /*#__PURE__*/React.createElement("div", {
    className: styles$c["function"] + " "
  }, !hideSlideFlag ? getSlider() : null, /*#__PURE__*/React.createElement("div", {
    className: styles$c['footer-img']
  }, /*#__PURE__*/React.createElement("div", {
    className: styles$c['footer-left']
  }, !hidePalyFlag ? /*#__PURE__*/React.createElement("img", {
    className: styles$c['play-img'],
    src: isPlay ? BoFang : ZanTing,
    onClick: function onClick() {
      onClickPlay('play');
    }
  }) : null, !hideTimeFlag ? /*#__PURE__*/React.createElement("p", {
    className: styles$c['footer-time']
  }, /*#__PURE__*/React.createElement("span", null, formatTime(currentTime)), "/", /*#__PURE__*/React.createElement("span", null, formatTime(totalTime))) : null), /*#__PURE__*/React.createElement("div", {
    className: styles$c['footer-right']
  }, !hideVoiceFlag ? /*#__PURE__*/React.createElement("div", {
    className: styles$c['footer-img']
  }, /*#__PURE__*/React.createElement("img", {
    className: styles$c['play-img'],
    src: isBan ? JingYin : Shenyin,
    onClick: function onClick() {
      onClickPlay('voice');
    }
  })) : null, !hideBackFlag ? getPlaybackRateDom() : null, !hideDownloadFlag ? /*#__PURE__*/React.createElement("img", {
    src: Download,
    className: styles$c['play-img'] + " " + styles$c['footer-full'],
    onClick: function onClick() {
      downloadFile(src, id + "video");
    }
  }) : null, !hideFulllFlag ? /*#__PURE__*/React.createElement("img", {
    src: isFull ? QuanPin : ShuoXiao,
    className: styles$c['play-img'] + " " + styles$c['footer-full'],
    onClick: function onClick() {
      onClickPlay('full');
    }
  }) : null))) : null);
};

var useModal = function useModal(cancelCallback) {
  var _useState = useState(false),
    visible = _useState[0],
    setVisible = _useState[1];
  var afterModalClosed = useCallback(function () {
    var _global = global,
      _global$modal = _global.modal,
      modal = _global$modal === void 0 ? {} : _global$modal;
    modal === null || modal === void 0 ? void 0 : modal.pop();
  }, []);
  var close = useCallback(function () {
    setVisible(false);
  }, []);
  var handleClose = useCallback(function () {
    if (cancelCallback) {
      cancelCallback();
    }
    close();
  }, [cancelCallback, close]);
  useEffect(function () {
    setVisible(true);
  }, []);
  return {
    visible: visible,
    afterModalClosed: afterModalClosed,
    handleClose: handleClose,
    close: close
  };
};

var _excluded$4 = ["children", "cancelCallback"];
var BaseModal = forwardRef(function (props, ref) {
  var children = props.children,
    cancelCallback = props.cancelCallback,
    restProps = _objectWithoutPropertiesLoose(props, _excluded$4);
  var _useModal = useModal(cancelCallback),
    visible = _useModal.visible,
    afterModalClosed = _useModal.afterModalClosed,
    handleClose = _useModal.handleClose,
    close = _useModal.close;
  useImperativeHandle(ref, function () {
    return {
      close: close
    };
  });
  return React.createElement(Modal, Object.assign({
    centered: true,
    closable: false,
    title: "",
    footer: null,
    onCancel: handleClose,
    afterClose: afterModalClosed,
    visible: visible,
    bodyStyle: {
      padding: '0'
    }
  }, restProps), children);
});

var styles$d = {"alert-modal":"_Z8RLj","alert-modal-header":"_1aPOx","alert-modal-header-icon":"_aaEP_","alert-modal-content":"_2Reb8","alert-modal-footer":"_1zqUY"};

var AlertModal = function AlertModal(props) {
  var renderChildren = props.renderChildren,
    cancelHandle = props.cancelHandle,
    confirmHandle = props.confirmHandle,
    _props$confirmText = props.confirmText,
    confirmText = _props$confirmText === void 0 ? '确认' : _props$confirmText,
    onlyConfirm = props.onlyConfirm,
    _props$width = props.width,
    width = _props$width === void 0 ? 450 : _props$width,
    modalTitle = props.modalTitle;
  var throttleCancel = useMemo(function () {
    return _.throttle(function () {
      cancelHandle && cancelHandle();
    }, 2000);
  }, [cancelHandle]);
  var baseModalRef = useRef(null);
  var handleCancelClick = useCallback(function () {
    if (cancelHandle) {
      throttleCancel();
    }
    baseModalRef.current.close();
  }, [cancelHandle, throttleCancel]);
  var handleConfirmClick = useCallback(function () {
    try {
      var _temp2 = function () {
        if (confirmHandle) {
          return Promise.resolve(confirmHandle()).then(function (result) {
            if (result) {
              baseModalRef.current.close();
            }
          });
        }
      }();
      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  }, [confirmHandle]);
  return React.createElement(BaseModal, {
    ref: baseModalRef,
    width: width,
    cancelCallback: throttleCancel
  }, React.createElement("div", {
    className: styles$d['alert-modal']
  }, modalTitle && React.createElement("div", {
    className: styles$d['alert-modal-header']
  }, modalTitle, React.createElement(CloseOutlined, {
    className: styles$d['alert-modal-header-icon'],
    onClick: handleCancelClick
  })), React.createElement("div", {
    className: styles$d['alert-modal-content']
  }, renderChildren && renderChildren()), (confirmHandle || cancelHandle) && React.createElement("div", {
    className: styles$d['alert-modal-footer']
  }, !onlyConfirm && React.createElement(Button, {
    onClick: handleCancelClick
  }, "\u53D6\u6D88"), React.createElement(Button, {
    type: "primary",
    onClick: handleConfirmClick
  }, confirmText))));
};

var HocModal = function HocModal(props) {
  var RenderChildren = props.RenderChildren;
  return React.createElement(RenderChildren, null);
};

var styles$e = {"run-detail-wrapper":"_2o2Xz","run-detail-title":"_7iemU","description-item":"_1vepF","item-key":"_2RRPe","item-value":"_2dzeH"};

var DetailDrawer = function DetailDrawer(props) {
  var dataSource = props.dataSource,
    visible = props.visible,
    _onClose = props.onClose,
    width = props.width,
    afterVisibleChange = props.afterVisibleChange,
    restProps = props.restProps;
  var renderDescriptionItem = useCallback(function (_ref) {
    var _ref$label = _ref.label,
      label = _ref$label === void 0 ? '' : _ref$label,
      value = _ref.value;
    return React.createElement("div", {
      key: label,
      className: styles$e['description-item']
    }, React.createElement("span", {
      style: {
        width: label ? 100 : 0
      },
      className: styles$e['item-key']
    }, label), React.createElement("span", {
      className: styles$e['item-value']
    }, value));
  }, []);
  return React.createElement(Drawer, Object.assign({
    width: width,
    visible: visible,
    placement: "right",
    closable: true,
    afterVisibleChange: afterVisibleChange,
    onClose: function onClose() {
      _onClose && _onClose();
    }
  }, restProps), dataSource.map(function (ele) {
    return React.createElement("div", {
      key: ele.title,
      className: styles$e['run-detail-wrapper']
    }, React.createElement("h3", {
      className: styles$e['run-detail-title']
    }, ele.title), ele.data.map(function (val) {
      return renderDescriptionItem({
        label: val.label,
        value: val.value
      });
    }));
  }));
};

var _excluded$5 = ["showDetail", "cancelCallback", "width"];
var BaseDrawer = forwardRef(function (props, ref) {
  var showDetail = props.showDetail,
    cancelCallback = props.cancelCallback,
    _props$width = props.width,
    width = _props$width === void 0 ? 500 : _props$width,
    restProps = _objectWithoutPropertiesLoose(props, _excluded$5);
  var _useModal = useModal(cancelCallback),
    visible = _useModal.visible,
    afterModalClosed = _useModal.afterModalClosed,
    handleClose = _useModal.handleClose,
    close = _useModal.close;
  useImperativeHandle(ref, function () {
    return {
      close: close
    };
  });
  var handleVisibleChange = useCallback(function (visible) {
    if (!visible) {
      afterModalClosed();
    }
  }, [afterModalClosed]);
  return React.createElement(DetailDrawer, {
    dataSource: showDetail,
    width: width,
    visible: visible,
    restProps: _extends({}, restProps),
    afterVisibleChange: handleVisibleChange,
    onClose: handleClose
  });
});

var MAX_MODAL_NUMBER = 10;
var MODAL_COMPONENTS = {
  MODAL_ALERT: AlertModal,
  MODAL_HOC: HocModal,
  BASE_DRAWER: BaseDrawer
};
var ModalRoot = forwardRef(function (props, ref) {
  var modalComponents = props.modalComponents,
    _props$maxNumber = props.maxNumber,
    maxNumber = _props$maxNumber === void 0 ? MAX_MODAL_NUMBER : _props$maxNumber;
  var _useState = useState([]),
    availableModalList = _useState[0],
    setAvailableModalList = _useState[1];
  useImperativeHandle(ref, function () {
    return {
      show: show,
      clearModals: clearModals,
      pop: pop
    };
  });
  var show = useCallback(function (modalType, modalProps) {
    try {
      var composeComponents = _extends({}, modalComponents, MODAL_COMPONENTS);
      var newModalList = [].concat(availableModalList);
      if (newModalList.length < maxNumber) {
        newModalList.push({
          modalType: modalType,
          specificProps: modalProps,
          specificId: guid(),
          SpecificModal: composeComponents[modalType]
        });
        setAvailableModalList(newModalList);
      }
    } catch (error) {
      console.error(error);
    }
  }, [availableModalList, maxNumber, modalComponents]);
  var clearModals = useCallback(function () {
    setAvailableModalList([]);
  }, []);
  var pop = useCallback(function (deep, modalType) {
    try {
      var newModalList = [].concat(availableModalList);
      if (!newModalList.length) {
        return;
      }
      if (deep || modalType) {
        newModalList = newModalList.filter(function (val) {
          return val.modalType !== modalType;
        });
        newModalList.splice(newModalList.length - deep - 1, 1);
      } else {
        newModalList.pop();
      }
      setAvailableModalList(newModalList);
    } catch (error) {
      console.error(error);
    }
  }, [availableModalList]);
  return React.createElement(Fragment, null, availableModalList.map(function (_ref) {
    var specificProps = _ref.specificProps,
      SpecificModal = _ref.SpecificModal,
      specificId = _ref.specificId;
    return React.createElement(SpecificModal, Object.assign({
      key: specificId
    }, specificProps));
  }));
});

var ModalType;
(function (ModalType) {
  ModalType["MODAL_ALERT"] = "MODAL_ALERT";
  ModalType["MODAL_HOC"] = "MODAL_HOC";
  ModalType["BASE_DRAWER"] = "BASE_DRAWER";
})(ModalType || (ModalType = {}));

var index = {
  AlertModal: AlertModal,
  HocModal: HocModal,
  BaseDrawer: BaseDrawer,
  ModalType: ModalType,
  BaseModal: BaseModal,
  DetailDrawer: DetailDrawer,
  ModalRoot: ModalRoot
};

var styles$f = {"back-header":"_3RRJj"};

var SMBackHeader = function SMBackHeader(props) {
  var onClick = props.onClick,
    extendDom = props.extendDom,
    isStyle = props.isStyle;
  var handleClickBack = useCallback(function () {
    if (onClick) {
      onClick();
    } else {
      window.history.back();
    }
  }, [onClick]);
  return React.createElement("div", {
    className: isStyle ? styles$f['back-header'] : ''
  }, React.createElement("a", {
    onClick: handleClickBack
  }, '<<', " \u8FD4\u56DE\u4E0A\u4E00\u7EA7", ' '), extendDom && extendDom());
};

var styles$g = {"ctn":"_3JmHg","custom":"_2oPZR"};

var Search = Input.Search;
var INPUT_SEARCH = 'inputSearch';
var getOptions = function getOptions(selectProps) {
  var options = selectProps.options,
    _selectProps$labelNam = selectProps.labelName,
    labelName = _selectProps$labelNam === void 0 ? 'name' : _selectProps$labelNam,
    _selectProps$valueNam = selectProps.valueName,
    valueName = _selectProps$valueNam === void 0 ? 'id' : _selectProps$valueNam;
  return options.map(function (item) {
    return {
      label: item[labelName],
      value: item[valueName]
    };
  });
};
var index$1 = (function (props) {
  var formData = props.formData;
  var newFormData = useMemo(function () {
    return formData.map(function (item) {
      if (item.type !== INPUT_SEARCH) {
        return item;
      }
      var inputSearchProps = item.inputSearchProps,
        selectProps = item.selectProps,
        definition = item.definition;
      var buildCustomDom = function buildCustomDom() {
        var prefixSelector = React.createElement(Select, Object.assign({
          showSearch: true,
          optionFilterProp: "children",
          style: {
            width: 120
          }
        }, selectProps, {
          options: getOptions(selectProps)
        }));
        return React.createElement("div", {
          className: styles$g.custom
        }, React.createElement(Input.Group, {
          compact: true
        }, React.createElement(Search, Object.assign({
          addonBefore: prefixSelector,
          autoComplete: "off",
          placeholder: '请输入',
          allowClear: false
        }, inputSearchProps))));
      };
      return {
        type: 'insertDom',
        customDom: buildCustomDom,
        definition: {
          "var": (definition === null || definition === void 0 ? void 0 : definition["var"]) || 'customInputSearch'
        }
      };
    });
  }, [formData]);
  return React.createElement("div", {
    className: styles$g.ctn
  }, React.createElement(SMForm$1, Object.assign({}, props, {
    formProps: _extends({
      layout: 'inline'
    }, props.formProps || {}),
    itemWidth: "100%",
    submitText: "\u641C\u7D22",
    submitWrapperStyle: {
      flex: 1
    },
    formData: newFormData
  })));
});

var audioTypeEnum;
(function (audioTypeEnum) {
  audioTypeEnum["DETAIL"] = "detail";
  audioTypeEnum["LIST"] = "list";
})(audioTypeEnum || (audioTypeEnum = {}));
var defaultSpeedOptions = [0.5, 1, 1.5, 2, 3];
var opTypeEnum;
(function (opTypeEnum) {
  opTypeEnum["PAUSE"] = "pause";
  opTypeEnum["PLAY"] = "play";
  opTypeEnum["UPDATE_TIME"] = "updateCurrentTime";
  opTypeEnum["SILENCE"] = "silence";
  opTypeEnum["UN_SILENCE"] = "unSilence";
  opTypeEnum["SPEED"] = "speed";
  opTypeEnum["LOAD"] = "load";
})(opTypeEnum || (opTypeEnum = {}));

var styles$h = {"audio-wrapper":"_1VLLn","audio-play":"_3-Drc","audio-progress":"_mq53M","audio-progress-start":"_25N1S","audio-progress-end":"_1vOaY","audio-sound":"_3FNo8","audio-speed":"_3D9_g","audio-download":"_2Ak75","audio-load":"_WkYET","audio-speed-select":"_1IHlr","audio-speed-select-item":"_f8DoI"};

var SMAudio = forwardRef(function (props, ref) {
  var _props$showLoadFlag = props.showLoadFlag,
    showLoadFlag = _props$showLoadFlag === void 0 ? true : _props$showLoadFlag,
    _props$speedOptions = props.speedOptions,
    speedOptions = _props$speedOptions === void 0 ? defaultSpeedOptions : _props$speedOptions,
    _props$audioType = props.audioType,
    audioType = _props$audioType === void 0 ? audioTypeEnum.DETAIL : _props$audioType,
    audioUrl = props.audioUrl,
    audioId = props.audioId,
    showSpeedFlag = props.showSpeedFlag,
    showDownloadFlag = props.showDownloadFlag,
    _props$showSilenceFla = props.showSilenceFlag,
    showSilenceFlag = _props$showSilenceFla === void 0 ? true : _props$showSilenceFla,
    onPauseChange = props.onPauseChange;
  var isListType = audioType === audioTypeEnum.LIST;
  var _props$width = props.width,
    width = _props$width === void 0 ? isListType ? 150 : 300 : _props$width;
  var _useState = useState(false),
    isPlay = _useState[0],
    setPlayStatus = _useState[1];
  var _useState2 = useState(false),
    isSilence = _useState2[0],
    setSilenceStatus = _useState2[1];
  var _useState3 = useState(0),
    currentTime = _useState3[0],
    setCurrentTime = _useState3[1];
  var _useState4 = useState(0),
    totalTime = _useState4[0],
    setTotalTime = _useState4[1];
  var _useState5 = useState(1),
    speed = _useState5[0],
    setSpeed = _useState5[1];
  var _useState6 = useState(false),
    speedVisible = _useState6[0],
    setSpeedVisible = _useState6[1];
  var _useState7 = useState(true),
    loading = _useState7[0],
    setLoading = _useState7[1];
  var audioEl = useRef(null);
  useInterval(function () {
    if (audioEl.current) {
      setCurrentTime(audioEl.current.currentTime || 0);
    }
  }, isPlay ? 300 : null);
  var operation = useCallback(function (type, val) {
    if (!audioEl.current) {
      return;
    }
    switch (type) {
      case opTypeEnum.PAUSE:
        setPlayStatus(false);
        audioEl.current.pause();
        break;
      case opTypeEnum.PLAY:
        setPlayStatus(true);
        audioEl.current.play();
        break;
      case opTypeEnum.UPDATE_TIME:
        audioEl.current.currentTime = val;
        audioEl.current.play();
        setPlayStatus(true);
        break;
      case opTypeEnum.SILENCE:
        setSilenceStatus(true);
        audioEl.current.volume = 0;
        break;
      case opTypeEnum.UN_SILENCE:
        setSilenceStatus(false);
        audioEl.current.volume = 1;
        break;
      case opTypeEnum.SPEED:
        setSpeed(val);
        audioEl.current.playbackRate = val;
        setSpeedVisible(false);
        break;
      case opTypeEnum.LOAD:
        setLoading(true);
        audioEl.current.load();
        break;
    }
  }, []);
  var stopLoading = useCallback(function () {
    setTimeout(function () {
      setLoading(false);
    }, 600);
  }, []);
  var handleAudioLoad = useCallback(function () {
    if (audioEl.current && audioEl.current.readyState > 0) {
      setTotalTime(audioEl.current.duration);
    }
    stopLoading();
  }, [stopLoading]);
  var handlePlayEnded = useCallback(function () {
    setTimeout(function () {
      setPlayStatus(false);
    }, 300);
  }, []);
  var renderSpeedOptions = useCallback(function () {
    return React.createElement("div", {
      className: styles$h['audio-speed-select']
    }, speedOptions.map(function (val) {
      return React.createElement("div", {
        className: styles$h['audio-speed-select-item'],
        key: val,
        onClick: function onClick() {
          operation(opTypeEnum.SPEED, val);
        }
      }, val.toFixed(1));
    }));
  }, [operation, speedOptions]);
  var getAudioElement = useCallback(function () {
    return audioEl && audioEl.current;
  }, []);
  useEffect(function () {
    if (audioEl.current) {
      audioEl.current.addEventListener('canplay', handleAudioLoad);
      audioEl.current.addEventListener('ended', handlePlayEnded);
      audioEl.current.addEventListener('error', stopLoading);
    }
    return function () {
      if (audioEl.current) {
        audioEl.current.removeEventListener('canplay', handleAudioLoad);
        audioEl.current.removeEventListener('ended', handlePlayEnded);
        audioEl.current.removeEventListener('error', stopLoading);
      }
    };
  }, [stopLoading, handleAudioLoad, handlePlayEnded]);
  useImperativeHandle(ref, function () {
    return {
      setCurrentTime: setCurrentTime,
      operation: operation,
      getAudioElement: getAudioElement
    };
  });
  return React.createElement("div", {
    className: styles$h['audio-wrapper'],
    style: {
      backgroundColor: isListType ? 'transparent' : '#ecf2f9',
      padding: isListType ? '10px 0px' : '15px 20px',
      minWidth: width
    }
  }, isPlay ? React.createElement(PauseCircleFilled, {
    className: styles$h['audio-play'],
    onClick: function onClick() {
      onPauseChange && onPauseChange(opTypeEnum.PAUSE);
      operation(opTypeEnum.PAUSE);
    }
  }) : React.createElement(PlayCircleFilled, {
    className: styles$h['audio-play'],
    onClick: function onClick() {
      onPauseChange && onPauseChange(opTypeEnum.PLAY);
      operation(opTypeEnum.PLAY);
    }
  }), React.createElement("div", {
    className: styles$h['audio-progress']
  }, React.createElement(Slider, {
    value: currentTime / totalTime * 100,
    tooltipVisible: false,
    onAfterChange: function onAfterChange(e) {
      operation(opTypeEnum.UPDATE_TIME, totalTime * e / 100);
    },
    onChange: function onChange(e) {
      operation(opTypeEnum.PAUSE);
      setCurrentTime(totalTime * e / 100);
    }
  }), React.createElement("span", {
    className: styles$h['audio-progress-start']
  }, moment(currentTime * 1000).format('mm:ss')), React.createElement("span", {
    className: styles$h['audio-progress-end']
  }, moment(totalTime * 1000).format('mm:ss'))), showSilenceFlag && React.createElement(SoundOutlined, {
    className: styles$h['audio-sound'],
    style: {
      color: isSilence ? '#cfd8e4' : '#75e8e9'
    },
    onClick: function onClick() {
      operation(isSilence ? opTypeEnum.UN_SILENCE : opTypeEnum.SILENCE);
    }
  }), showSpeedFlag && React.createElement(Popover, {
    overlayStyle: {
      width: 50,
      overflow: 'hidden'
    },
    visible: speedVisible,
    trigger: "click",
    content: renderSpeedOptions(),
    onVisibleChange: setSpeedVisible
  }, React.createElement("div", {
    className: styles$h['audio-speed']
  }, React.createElement("span", null, "\u500D\u901F"), React.createElement("span", null, speed.toFixed(1)))), showDownloadFlag && React.createElement(DownloadOutlined, {
    className: styles$h['audio-download'],
    title: "\u4E0B\u8F7D",
    onClick: function onClick() {
      downloadFile(audioUrl, audioId + "-audio");
    }
  }), showLoadFlag && React.createElement(RedoOutlined, {
    spin: loading,
    className: styles$h['audio-load'],
    title: "\u91CD\u65B0\u52A0\u8F7D",
    onClick: function onClick() {
      if (loading) {
        return;
      }
      operation(opTypeEnum.LOAD);
    }
  }), React.createElement("audio", {
    ref: audioEl,
    src: audioUrl
  }));
});

var styles$i = {"sm-text":"_1bG8T","will-ellips":"_2wmKz","not-ellips":"_2bPHo"};

var KeywordsHighLight = function KeywordsHighLight(props) {
  var _props$keywords = props.keywords,
    keywords = _props$keywords === void 0 ? '' : _props$keywords,
    _props$content = props.content,
    content = _props$content === void 0 ? '' : _props$content,
    _props$defaultContent = props.defaultContent,
    defaultContent = _props$defaultContent === void 0 ? '' : _props$defaultContent,
    _props$ellipsis = props.ellipsis,
    ellipsis = _props$ellipsis === void 0 ? false : _props$ellipsis,
    _props$color = props.color,
    color = _props$color === void 0 ? 'red' : _props$color,
    _props$delimiter = props.delimiter,
    delimiter = _props$delimiter === void 0 ? '|' : _props$delimiter,
    _props$escapeHtmlFlag = props.escapeHtmlFlag,
    escapeHtmlFlag = _props$escapeHtmlFlag === void 0 ? false : _props$escapeHtmlFlag;
  var finalHtml = useMemo(function () {
    var storeHtml = content;
    if (!storeHtml) {
      return "<div style=\"wordBreak: break-all\">" + (defaultContent || '-') + "</div>";
    }
    if (escapeHtmlFlag) {
      storeHtml = _.escape(storeHtml);
    }
    if (keywords) {
      var matchedArrReg = new RegExp("" + _.escapeRegExp(delimiter), 'g');
      var matchedArr = keywords.replace(matchedArrReg, ',').split(',').sort();
      var regText = '';
      _.uniq(matchedArr).forEach(function (word) {
        word = _.escapeRegExp(word);
        if (word) {
          regText = regText ? regText + "|" + word : word;
        }
      });
      var reg = new RegExp("(" + regText + ")", 'g');
      storeHtml = storeHtml.replace(reg, function (str) {
        return "<span class=\"highlight\" style=\"color: " + color + ";font-weight: bold;\">" + str + "</span>";
      });
    }
    return storeHtml;
  }, [color, content, defaultContent, delimiter, escapeHtmlFlag, keywords]);
  var ellipsisStyle = ellipsis ? 'will-ellips' : 'not-ellips';
  return React.createElement("div", {
    className: "sm-text " + styles$i['sm-text'] + " " + styles$i[ellipsisStyle],
    dangerouslySetInnerHTML: {
      __html: finalHtml
    }
  });
};

var SMLink = function SMLink(props) {
  var key = props.key,
    to = props.to,
    history = props.history,
    replace = props.replace,
    innerRef = props.innerRef,
    style = props.style,
    beforeLeave = props.beforeLeave,
    beforeRouteEnter = props.beforeRouteEnter;
  var isString = _.isString(to);
  var splicingUrl = useCallback(function () {
    if (isString) {
      return to;
    }
    if (!_.isPlainObject(to)) {
      return '';
    }
    var _to$pathname = to.pathname,
      pathname = _to$pathname === void 0 ? '/' : _to$pathname,
      _to$query = to.query,
      query = _to$query === void 0 ? {} : _to$query;
    if (!_.isPlainObject(query)) {
      return pathname;
    }
    var params = '';
    for (var _key in query) {
      if (!params) {
        params = "?" + _key + "=" + query[_key];
      } else {
        params = params + "&" + _key + "=" + query[_key];
      }
    }
    return pathname + params;
  }, [isString, to]);
  var newInterface = useCallback(function (href) {
    var a = document.createElement('a');
    a.setAttribute('href', href);
    a.setAttribute('target', '_blank');
    a.setAttribute('rel', 'noopener noreferrer');
    document.body.appendChild(a);
    a.click();
    a.remove();
  }, []);
  var isQueryOrState = useCallback(function (params) {
    if (replace) {
      history && history.replace(params);
    } else {
      history && history.push(params);
    }
  }, [history, replace]);
  var jumpRoute = useCallback(function (e) {
    e.preventDefault();
    if (e.button === 0 && e.ctrlKey || e.button === 0 && e.metaKey) {
      beforeRouteEnter && beforeRouteEnter();
      newInterface(splicingUrl());
      return false;
    }
    beforeLeave && beforeLeave();
    if (isString) {
      isQueryOrState({
        pathname: to
      });
    } else {
      isQueryOrState(to);
    }
  }, [beforeLeave, beforeRouteEnter, isQueryOrState, isString, newInterface, splicingUrl, to]);
  var url = splicingUrl();
  return React.createElement("a", {
    key: key,
    href: url,
    ref: innerRef,
    onClick: function onClick(e) {
      return jumpRoute(e);
    },
    style: style
  }, props.children);
};
var index$2 = withRouter(SMLink);

var styles$j = {};

var SPLIT = '：';
var ALL_NAME = '全部';
var SPECIAL_SPLIT = '__$$__';
var KEYBOARD_CODER = {
  ENTER: 'Enter'
};
var getNodeLevel = function getNodeLevel(node, fieldNames) {
  if (!node) {
    return 0;
  }
  var childrenName = fieldNames.children;
  if (_.isArray(node[childrenName]) && node[childrenName].length) {
    var sonLevel = [];
    node[childrenName].forEach(function (child) {
      return sonLevel.push(getNodeLevel(child, fieldNames));
    });
    return 1 + Math.max.apply(Math, sonLevel);
  } else {
    return 1;
  }
};
var getAllValues = function getAllValues(options, fieldNames) {
  var valueName = fieldNames.value,
    childrenName = fieldNames.children;
  var result = [];
  _.forEach(options, function (item) {
    if (_.size(item[childrenName]) > 0) {
      result.push.apply(result, getAllValues(item[childrenName], fieldNames).map(function (path) {
        return [item[valueName]].concat(path);
      }));
    } else {
      result.push([item[valueName]]);
    }
  });
  return result;
};
var getAllValueLabelMap = function getAllValueLabelMap(options, fieldNames) {
  var valueName = fieldNames.value,
    labelName = fieldNames.label,
    childrenName = fieldNames.children;
  var result = {};
  var digui = function digui(nodes) {
    if (!nodes || _.size(nodes) === 0) {
      return;
    }
    _.forEach(nodes, function (item) {
      result[item[valueName]] = item[labelName];
      digui(item[childrenName]);
    });
  };
  digui(options);
  return result;
};
var SMCascader = React.forwardRef(function (props, ref) {
  var _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$fieldNames = props.fieldNames,
    fieldNames = _props$fieldNames === void 0 ? {
      value: 'value',
      label: 'label',
      children: 'children'
    } : _props$fieldNames,
    _props$options = props.options,
    options = _props$options === void 0 ? [] : _props$options,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? true : _props$multiple,
    _props$expandTrigger = props.expandTrigger,
    expandTrigger = _props$expandTrigger === void 0 ? 'hover' : _props$expandTrigger,
    _props$showCheckedStr = props.showCheckedStrategy,
    showCheckedStrategy = _props$showCheckedStr === void 0 ? Cascader.SHOW_PARENT : _props$showCheckedStr,
    _props$antProps = props.antProps,
    antProps = _props$antProps === void 0 ? {} : _props$antProps,
    _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    _props$maxTagCount = props.maxTagCount,
    maxTagCount = _props$maxTagCount === void 0 ? 3 : _props$maxTagCount,
    _props$allowClear = props.allowClear,
    allowClear = _props$allowClear === void 0 ? true : _props$allowClear,
    _props$defaultValue = props.defaultValue,
    defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
    _props$value = props.value,
    propsValue = _props$value === void 0 ? [] : _props$value,
    _props$disabled = props.disabled,
    disabled = _props$disabled === void 0 ? false : _props$disabled,
    onChange = props.onChange,
    onEnter = props.onEnter;
  var allValues = useMemo(function () {
    return getAllValues(options, fieldNames);
  }, [options, fieldNames]);
  var allValueLabelMap = useMemo(function () {
    return getAllValueLabelMap(options, fieldNames);
  }, [options, fieldNames]);
  var firstLevelIds = useMemo(function () {
    var firstLevelIds = [];
    var valueName = fieldNames.value;
    _.forEach(options, function (option) {
      firstLevelIds.push([option[valueName]]);
    });
    return firstLevelIds;
  }, [options, fieldNames]);
  var allValueMap = useMemo(function () {
    var result = {};
    _.forEach(allValues, function (item) {
      result[item.join(SPECIAL_SPLIT)] = item;
    });
    return result;
  }, [allValues]);
  var _useTranslation = useTranslation(),
    t = _useTranslation.t;
  var _useState = useState(defaultValue),
    value = _useState[0],
    setValue = _useState[1];
  var allChecked = useMemo(function () {
    return value.length > 0 && value.length === allValues.length;
  }, [value, allValues]);
  var allCheckedIndeterminate = useMemo(function () {
    return value.length > 0 && value.length < allValues.length;
  }, [value, allValues]);
  var getLabelsByValue = useCallback(function (value) {
    var labels = [];
    _.forEach(value, function (item) {
      var label = _.map(item, function (id) {
        return allValueLabelMap[id];
      }).join(SPLIT);
      labels.push(label);
    });
    return labels;
  }, [allValueLabelMap]);
  var displayRender = useCallback(function (label, selectedOptions) {
    if (selectedOptions.length > 0) {
      var rootNode = selectedOptions[selectedOptions.length - 1];
      var nodeLevel = getNodeLevel(rootNode, fieldNames);
      var childrenLevel = nodeLevel - 1;
      for (var i = 0; i < childrenLevel; i++) {
        label.push(t(ALL_NAME));
      }
    }
    return label.join(SPLIT);
  }, [fieldNames, t]);
  var getShortLabelFormat = useCallback(function (shortLabels, labels) {
    var result = [];
    shortLabels.forEach(function (shortLabel) {
      var maxLabel = '';
      for (var i = 0; i < labels.length; i++) {
        if (labels[i].indexOf(shortLabel) === 0 && labels[i].length > maxLabel.length) {
          maxLabel = labels[i];
        }
      }
      var moreLevel = maxLabel.split(SPLIT).length - shortLabel.split(SPLIT).length;
      var shortLabelFormat = shortLabel;
      if (moreLevel > 0) {
        for (var _i = 0; _i < moreLevel; _i++) {
          shortLabelFormat += "" + SPLIT + t(ALL_NAME);
        }
      }
      result.push(shortLabelFormat);
    });
    return result;
  }, [t]);
  var handleChange = useCallback(function (currentValue) {
    var keyArray = _.map(currentValue, function (item) {
      return item.join(SPECIAL_SPLIT);
    });
    var newValue = [];
    _.forEach(keyArray, function (key) {
      for (var entireKey in allValueMap) {
        if (entireKey.indexOf(key) === 0) {
          newValue.push(allValueMap[entireKey]);
        }
      }
    });
    setValue(newValue);
    var labels = getLabelsByValue(newValue);
    var shortLabels = getLabelsByValue(currentValue);
    onChange === null || onChange === void 0 ? void 0 : onChange({
      value: newValue,
      labels: labels,
      shortValues: currentValue,
      shortLabels: shortLabels,
      allChecked: newValue.length > 0 && newValue.length === allValues.length
    });
  }, [allValues, allValueMap]);
  var handleAllCheckedChange = useCallback(function () {
    var newValue = allChecked ? [] : firstLevelIds;
    handleChange(newValue);
  }, [allChecked, handleChange, firstLevelIds]);
  var handleKeyDown = useCallback(function (e) {
    if (onEnter && e.key === KEYBOARD_CODER.ENTER) {
      e.stopPropagation();
      onEnter();
    }
  }, [onEnter]);
  var dropdownRender = useCallback(function (menus) {
    return React.createElement("div", null, React.createElement(Checkbox, {
      checked: allChecked,
      indeterminate: allCheckedIndeterminate,
      onChange: handleAllCheckedChange,
      style: {
        marginLeft: 12,
        marginBottom: 6
      }
    }, t(ALL_NAME)), menus);
  }, [allChecked, allCheckedIndeterminate, handleAllCheckedChange, t]);
  var maxTagPlaceholder = useCallback(function (omittedValues) {
    if (allChecked) {
      return React.createElement("div", null, t(ALL_NAME));
    }
    if (_.size(omittedValues) > 0) {
      return React.createElement(Tooltip, {
        className: "sm-cascader-tooltip",
        title: _.map(omittedValues, 'label').join('、'),
        overlayInnerStyle: {
          maxHeight: 300,
          overflow: 'auto'
        }
      }, React.createElement("span", {
        className: "more-span"
      }, "..."));
    }
    return null;
  }, [allChecked, t]);
  useImperativeHandle(ref, function () {
    return {
      getShortLabelFormat: getShortLabelFormat,
      setValue: setValue,
      getLabelsByValue: getLabelsByValue
    };
  });
  useEffect(function () {
    setValue(propsValue);
  }, [propsValue]);
  return React.createElement("div", {
    className: "sm-cascader " + className
  }, React.createElement(Cascader, Object.assign({
    className: styles$j.select,
    style: _.extend({
      width: 'auto',
      minWidth: 212
    }, style),
    options: options,
    value: value,
    disabled: disabled,
    fieldNames: fieldNames,
    multiple: multiple,
    expandTrigger: expandTrigger,
    showCheckedStrategy: showCheckedStrategy,
    maxTagCount: allChecked ? 0 : maxTagCount,
    displayRender: displayRender,
    maxTagPlaceholder: maxTagPlaceholder,
    tagRender: allChecked ? function () {
      return null;
    } : null,
    allowClear: allowClear,
    showSearch: true,
    placeholder: ALL_NAME,
    dropdownRender: dropdownRender,
    onChange: handleChange,
    onInputKeyDown: handleKeyDown
  }, antProps)));
});

export { BatchOperationBar, CustomizeRenderEmpty, IconLoading, SMAudio, SMBackHeader, SMCascader, SMDatePicker, SMForm$1 as SMForm, SMForm as SMFormV2, SMImage, SMImageTable, index$2 as SMLink, index as SMModal, SMMultipleSelect, index$1 as SMSearchForm, SMSelect, SMTable, SMTagSelect, KeywordsHighLight as SMText, SMTextSection, SMUpload, SMVideo };
//# sourceMappingURL=index.modern.js.map
