/// <reference types="react" />
/// <reference types="react-i18next" />
export interface TableState {
    pagination?: Pagination;
    rowSelection?: RowSelection;
}
export interface Pagination {
    total?: number;
    showSizeChanger?: boolean;
    pageSize?: number;
    defaultPageSize?: number;
    current?: number;
    pageSizeOptions?: Array<string>;
    showTotal?: (total: number) => string;
    showQuickJumper?: boolean;
}
export interface RowSelection {
    selectedRowKeys?: Array<string>;
    cleanSelect?: () => void;
    onChange?: () => void;
}
export declare type ColumnsState = {
    show?: boolean;
    fixed?: 'right' | 'left' | undefined;
    order?: number;
};
export declare type i18nProps = {
    columnDisplay?: string;
    columnSetting?: string;
    reset?: string;
    unfixed?: string;
    fixedFirst?: string;
    fixedLast?: string;
    fixedLeft?: string;
    selectText?: string;
    totalText?: string;
    itemText?: string;
};
export declare const genColumnKey: (key?: import("react").ReactText, index?: number) => string;
